#pragma once

/*
Version 1.0.0
*/

#include <windows.h>
#include "MM Engine Addons.h"

#define ASM_EAX 0xB8
#define ASM_ECX 0xB9
#define ASM_EDX 0xBA
#define ASM_EBX 0xBB
#define ASM_ESP 0xBC
#define ASM_EBP 0xBD
#define ASM_ESI 0xBE
#define ASM_EDI 0xBF

namespace assembler
{
	void DS patch(uintptr_t _Address, UINT _Bytes, size_t _Size);

	void DS fill(uintptr_t _Address, UINT _Bytes, size_t _Size);

	void DS jmp(uintptr_t _Address, uintptr_t _Destination);

	void DS call(uintptr_t _Address, uintptr_t _Destination);

	void DS push(uintptr_t _Address, uintptr_t _Destination, bool _Only4Byte = false);

	void DS mov(uintptr_t _Address, UINT _Bytes, UINT _Register = ASM_EAX);

	template<typename R>
	inline R DS memloc(size_t _Size)
	{
		return (R)calloc(_Size, sizeof(char));
	}
}