#pragma once

/*
Version 1.0.0
*/

#include <Windows.h>
#include "MM Engine Addons.h"

#define jNATIVE __cdecl

using int8 = signed char;
using int16 = short;
using int32 = int;
using int64 = long long;
using uint8 = unsigned char;
using uint16 = unsigned short;
using uint32 = unsigned int;
using uint64 = unsigned long long;

typedef void   jNothing;
typedef uint32 jBoolean;
typedef uint32 jCode;
typedef uint32 jHandle;
typedef int32  jInteger;
typedef uint32 jReal;
typedef uint32 jString;
typedef uint32 jTrigger;

const jBoolean jTrue = 1;
const jBoolean jFalse = 0;
const jHandle jNull = 0;

typedef DWORD HUNIT;
typedef DWORD HWIDGET;
typedef DWORD HLIGHTNING;
typedef DWORD HPLAYER;
typedef DWORD HEFFECT;
typedef DWORD HLOCATION;
typedef DWORD HEFFECTTYPE;
typedef DWORD HRECT;
typedef DWORD HWEATHEREFFECT;
typedef DWORD HCAMERAFIELD;
typedef DWORD HBOOLEXPR;
typedef DWORD HSOUND;
typedef DWORD HCAMERASETUP;
typedef DWORD HITEMTYPE;
typedef DWORD HCONDITIONFUNC;
typedef DWORD HAIDIFFICULTY;
typedef DWORD HALLIANCETYPE;
typedef DWORD HATTACKTYPE;
typedef DWORD HBLENDMODE;
typedef DWORD HDAMAGETYPE;
typedef DWORD HDIALOGEVENT;
typedef DWORD HFGAMESTATE;
typedef DWORD HFOGSTATE;
typedef DWORD HGAMEDIFFICULTY;
typedef DWORD HGAMEEVENT;
typedef DWORD HGAMESPEED;
typedef DWORD HGAMETYPE;
typedef DWORD HIGAMESTATE;
typedef DWORD HLIMITOP;
typedef DWORD HMAPCONTROL;
typedef DWORD HMAPDENSITY;
typedef DWORD HMAPFLAG;
typedef DWORD HMAPSETTING;
typedef DWORD HMAPVISIBILITY;
typedef DWORD HPATHINGTYPE;
typedef DWORD HPLACEMENT;
typedef DWORD HPLAYERCOLOR;
typedef DWORD HPLAYEREVENT;
typedef DWORD HPLAYERGAMERESULT;
typedef DWORD HPLAYERSCORE;
typedef DWORD HPLAYERSLOTSTATE;
typedef DWORD HPLAYERSTATE;
typedef DWORD HPLAYERUNITEVENT;
typedef DWORD HRACE;
typedef DWORD HRACEPREFERENCE;
typedef DWORD HRARITYCONTROL;
typedef DWORD HSOUNDTYPE;
typedef DWORD HSTARTLOCPRIO;
typedef DWORD HTEXMAPFLAGS;
typedef DWORD HUNITEVENT;
typedef DWORD HUNITSTATE;
typedef DWORD HUNITTYPE;
typedef DWORD HVERSION;
typedef DWORD HVOLUMEGROUP;
typedef DWORD HWEAPONTYPE;
typedef DWORD HWIDGETEVENT;
typedef DWORD HDESTRUCTABLE;
typedef DWORD HDEFEATCONDITION;
typedef DWORD HFOGMODIFIER;
typedef DWORD HFORCE;
typedef DWORD HGROUP;
typedef DWORD HIMAGE;
typedef DWORD HITEM;
typedef DWORD HITEMPOOL;
typedef DWORD HLEADERBOARD;
typedef DWORD HMULTIBOARD;
typedef DWORD HQUEST;
typedef DWORD HREGION;
typedef DWORD HTEXTTAG;
typedef DWORD HTIMER;
typedef DWORD HTIMERDIALOG;
typedef DWORD HTRACKABLE;
typedef DWORD HUBERSPLAT;
typedef DWORD HUNITPOOL;
typedef DWORD HFILTERFUNC;
typedef DWORD HDIALOG;
typedef DWORD HBUTTON;
typedef DWORD HHASHTABLE;
typedef DWORD HGAMECACHE;
typedef DWORD HGAMESTATE;
typedef DWORD HHANDLE2;
typedef DWORD HABILITY;
typedef DWORD HEVENTID;
typedef DWORD HQUESTITEM;
typedef DWORD HMULTIBOARDITEM;
typedef DWORD HTRIGGERACTION;
typedef DWORD HTRIGGERCONDITION;
typedef DWORD HEVENT;
typedef DWORD HAGENT;
typedef DWORD HTERRAINDEFORMATION;

namespace JassAPI
{
	float DS from_jReal(jReal val);
	jReal DS to_jReal(float val);
	LPCSTR DS from_jString(jString val);

	void DS BindNative(uintptr_t uCallback, LPCSTR lpName, LPCSTR lpArguments);

	// Natives
	jInteger DS AbilityId(jString abilityIdString);
	jString DS AbilityId2String(jInteger abilityId);
	jReal DS Acos(jReal* x);
	jBoolean DS AddAssault(jInteger arg1, jInteger arg2);
	jBoolean DS AddDefenders(jInteger arg1, jInteger arg2);
	jNothing DS AddGuardPost(jInteger arg1, jReal* arg2, jReal* arg3);
	jNothing DS AddHeroXP(HUNIT whichHero, jInteger xpToAdd, jBoolean showEyeCandy);
	jNothing DS AddIndicator(HWIDGET whichWidget, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS AddItemToAllStock(jInteger itemId, jInteger currentStock, jInteger stockMax);
	jNothing DS AddItemToStock(HUNIT whichUnit, jInteger itemId, jInteger currentStock, jInteger stockMax);
	HLIGHTNING DS AddLightning(jString codeName, jBoolean checkVisibility, jReal* x1, jReal* y1, jReal* x2, jReal* y2);
	HLIGHTNING DS AddLightningEx(jString codeName, jBoolean checkVisibility, jReal* x1, jReal* y1, jReal* z1, jReal* x2, jReal* y2, jReal* z2);
	jNothing DS AddPlayerTechResearched(HPLAYER whichPlayer, jInteger techid, jInteger levels);
	jNothing DS AddResourceAmount(HUNIT whichUnit, jInteger amount);
	HEFFECT DS AddSpecialEffect(jString modelName, jReal* x, jReal* y);
	HEFFECT DS AddSpecialEffectLoc(jString modelName, HLOCATION where);
	HEFFECT DS AddSpecialEffectTarget(jString modelName, HWIDGET targetWidget, jString attachPointName);
	HEFFECT DS AddSpellEffect(jString abilityString, HEFFECTTYPE t, jReal* x, jReal* y);
	HEFFECT DS AddSpellEffectById(jInteger abilityId, HEFFECTTYPE t, jReal* x, jReal* y);
	HEFFECT DS AddSpellEffectByIdLoc(jInteger abilityId, HEFFECTTYPE t, HLOCATION where);
	HEFFECT DS AddSpellEffectLoc(jString abilityString, HEFFECTTYPE t, HLOCATION where);
	HEFFECT DS AddSpellEffectTarget(jString modelName, HEFFECTTYPE t, HWIDGET targetWidget, jString attachPoint);
	HEFFECT DS AddSpellEffectTargetById(jInteger abilityId, HEFFECTTYPE t, HWIDGET targetWidget, jString attachPoint);
	jNothing DS AddUnitAnimationProperties(HUNIT whichUnit, jString animProperties, jBoolean add);
	jNothing DS AddUnitToAllStock(jInteger unitId, jInteger currentStock, jInteger stockMax);
	jNothing DS AddUnitToStock(HUNIT whichUnit, jInteger unitId, jInteger currentStock, jInteger stockMax);
	HWEATHEREFFECT DS AddWeatherEffect(HRECT where, jInteger effectID);
	jNothing DS AdjustCameraField(HCAMERAFIELD whichField, jReal* offset, jReal* duration);
	HBOOLEXPR DS And(HBOOLEXPR operandA, HBOOLEXPR operandB);
	jReal DS Asin(jReal* y);
	jReal DS Atan(jReal* x);
	jReal DS Atan2(jReal* y, jReal* x);
	jNothing DS AttachSoundToUnit(HSOUND soundHandle, HUNIT whichUnit);
	jNothing DS AttackMoveKill(HUNIT arg1);
	jNothing DS AttackMoveXY(jInteger arg1, jInteger arg2);
	jNothing DS CachePlayerHeroData(HPLAYER whichPlayer);
	jNothing DS CameraSetSmoothingFactor(jReal* factor);
	jNothing DS CameraSetSourceNoise(jReal* mag, jReal* velocity);
	jNothing DS CameraSetSourceNoiseEx(jReal* mag, jReal* velocity, jBoolean vertOnly);
	jNothing DS CameraSetTargetNoise(jReal* mag, jReal* velocity);
	jNothing DS CameraSetTargetNoiseEx(jReal* mag, jReal* velocity, jBoolean vertOnly);
	jNothing DS CameraSetupApply(HCAMERASETUP whichSetup, jBoolean doPan, jBoolean panTimed);
	jNothing DS CameraSetupApplyForceDuration(HCAMERASETUP whichSetup, jBoolean doPan, jReal* forceDuration);
	jNothing DS CameraSetupApplyForceDurationWithZ(HCAMERASETUP whichSetup, jReal* zDestOffset, jReal* forceDuration);
	jNothing DS CameraSetupApplyWithZ(HCAMERASETUP whichSetup, jReal* zDestOffset);
	HLOCATION DS CameraSetupGetDestPositionLoc(HCAMERASETUP whichSetup);
	jReal DS CameraSetupGetDestPositionX(HCAMERASETUP whichSetup);
	jReal DS CameraSetupGetDestPositionY(HCAMERASETUP whichSetup);
	jReal DS CameraSetupGetField(HCAMERASETUP whichSetup, HCAMERAFIELD whichField);
	jNothing DS CameraSetupSetDestPosition(HCAMERASETUP whichSetup, jReal* x, jReal* y, jReal* duration);
	jNothing DS CameraSetupSetField(HCAMERASETUP whichSetup, HCAMERAFIELD whichField, jReal* value, jReal* duration);
	jBoolean DS CaptainAtGoal();
	jNothing DS CaptainAttack(jReal* arg1, jReal* arg2);
	jNothing DS CaptainGoHome();
	jInteger DS CaptainGroupSize();
	jBoolean DS CaptainInCombat(jBoolean arg1);
	jBoolean DS CaptainIsEmpty();
	jBoolean DS CaptainIsFull();
	jBoolean DS CaptainIsHome();
	jInteger DS CaptainReadiness();
	jInteger DS CaptainReadinessHP();
	jInteger DS CaptainReadinessMa();
	jBoolean DS CaptainRetreating();
	jNothing DS CaptainVsPlayer(HPLAYER arg1);
	jNothing DS CaptainVsUnits(HPLAYER arg1);
	jNothing DS ChangeLevel(jString newLevel, jBoolean doScoreScreen);
	jNothing DS Cheat(jString cheatStr);
	jInteger DS ChooseRandomCreep(jInteger level);
	jInteger DS ChooseRandomItem(jInteger level);
	jInteger DS ChooseRandomItemEx(HITEMTYPE whichType, jInteger level);
	jInteger DS ChooseRandomNPBuilding();
	jNothing DS ClearCaptainTargets();
	jNothing DS ClearHarvestAI();
	jNothing DS ClearMapMusic();
	jNothing DS ClearSelection();
	jNothing DS ClearStackedSound(jString arg1, jReal* arg2, jReal* arg3);
	jNothing DS ClearStackedSoundRect(jString arg1, HRECT arg2);
	jNothing DS ClearTextMessages();
	jNothing DS CommandAI(HPLAYER num, jInteger command, jInteger data);
	jInteger DS CommandsWaiting();
	HCONDITIONFUNC DS Condition(jCode func);
	HAIDIFFICULTY DS ConvertAIDifficulty(jInteger i);
	HALLIANCETYPE DS ConvertAllianceType(jInteger i);
	HATTACKTYPE DS ConvertAttackType(jInteger i);
	HBLENDMODE DS ConvertBlendMode(jInteger i);
	HCAMERAFIELD DS ConvertCameraField(jInteger i);
	HDAMAGETYPE DS ConvertDamageType(jInteger i);
	HDIALOGEVENT DS ConvertDialogEvent(jInteger i);
	HEFFECTTYPE DS ConvertEffectType(jInteger i);
	HFGAMESTATE DS ConvertFGameState(jInteger i);
	HFOGSTATE DS ConvertFogState(jInteger i);
	HGAMEDIFFICULTY DS ConvertGameDifficulty(jInteger i);
	HGAMEEVENT DS ConvertGameEvent(jInteger i);
	HGAMESPEED DS ConvertGameSpeed(jInteger i);
	HGAMETYPE DS ConvertGameType(jInteger i);
	HIGAMESTATE DS ConvertIGameState(jInteger i);
	HITEMTYPE DS ConvertItemType(jInteger i);
	HLIMITOP DS ConvertLimitOp(jInteger i);
	HMAPCONTROL DS ConvertMapControl(jInteger i);
	HMAPDENSITY DS ConvertMapDensity(jInteger i);
	HMAPFLAG DS ConvertMapFlag(jInteger i);
	HMAPSETTING DS ConvertMapSetting(jInteger i);
	HMAPVISIBILITY DS ConvertMapVisibility(jInteger i);
	HPATHINGTYPE DS ConvertPathingType(jInteger i);
	HPLACEMENT DS ConvertPlacement(jInteger i);
	HPLAYERCOLOR DS ConvertPlayerColor(jInteger i);
	HPLAYEREVENT DS ConvertPlayerEvent(jInteger i);
	HPLAYERGAMERESULT DS ConvertPlayerGameResult(jInteger i);
	HPLAYERSCORE DS ConvertPlayerScore(jInteger i);
	HPLAYERSLOTSTATE DS ConvertPlayerSlotState(jInteger i);
	HPLAYERSTATE DS ConvertPlayerState(jInteger i);
	HPLAYERUNITEVENT DS ConvertPlayerUnitEvent(jInteger i);
	HRACE DS ConvertRace(jInteger i);
	HRACEPREFERENCE DS ConvertRacePref(jInteger i);
	HRARITYCONTROL DS ConvertRarityControl(jInteger i);
	HSOUNDTYPE DS ConvertSoundType(jInteger i);
	HSTARTLOCPRIO DS ConvertStartLocPrio(jInteger i);
	HTEXMAPFLAGS DS ConvertTexMapFlags(jInteger i);
	HUNITEVENT DS ConvertUnitEvent(jInteger i);
	HUNITSTATE DS ConvertUnitState(jInteger i);
	HUNITTYPE DS ConvertUnitType(jInteger i);
	jBoolean DS ConvertUnits(jInteger arg1, jInteger arg2);
	HVERSION DS ConvertVersion(jInteger i);
	HVOLUMEGROUP DS ConvertVolumeGroup(jInteger i);
	HWEAPONTYPE DS ConvertWeaponType(jInteger i);
	HWIDGETEVENT DS ConvertWidgetEvent(jInteger i);
	jBoolean DS CopySaveGame(jString sourceSaveName, jString destSaveName);
	jReal DS Cos(jReal* radians);
	HUNIT DS CreateBlightedGoldmine(HPLAYER id, jReal* x, jReal* y, jReal* face);
	HCAMERASETUP DS CreateCameraSetup();
	jNothing DS CreateCaptains();
	HUNIT DS CreateCorpse(HPLAYER whichPlayer, jInteger unitid, jReal* x, jReal* y, jReal* face);
	HDESTRUCTABLE DS CreateDeadDestructable(jInteger objectid, jReal* x, jReal* y, jReal* face, jReal* scale, jInteger variation);
	HDESTRUCTABLE DS CreateDeadDestructableZ(jInteger objectid, jReal* x, jReal* y, jReal* z, jReal* face, jReal* scale, jInteger variation);
	HDEFEATCONDITION DS CreateDefeatCondition();
	HDESTRUCTABLE DS CreateDestructable(jInteger objectid, jReal* x, jReal* y, jReal* face, jReal* scale, jInteger variation);
	HDESTRUCTABLE DS CreateDestructableZ(jInteger objectid, jReal* x, jReal* y, jReal* z, jReal* face, jReal* scale, jInteger variation);
	HFOGMODIFIER DS CreateFogModifierRadius(HPLAYER forWhichPlayer, HFOGSTATE whichState, jReal* centerx, jReal* centerY, jReal* radius, jBoolean useSharedVision, jBoolean afterUnits);
	HFOGMODIFIER DS CreateFogModifierRadiusLoc(HPLAYER forWhichPlayer, HFOGSTATE whichState, HLOCATION center, jReal* radius, jBoolean useSharedVision, jBoolean afterUnits);
	HFOGMODIFIER DS CreateFogModifierRect(HPLAYER forWhichPlayer, HFOGSTATE whichState, HRECT where, jBoolean useSharedVision, jBoolean afterUnits);
	HFORCE DS CreateForce();
	HGROUP DS CreateGroup();
	HIMAGE DS CreateImage(jString file, jReal* sizeX, jReal* sizeY, jReal* sizeZ, jReal* posX, jReal* posY, jReal* posZ, jReal* originX, jReal* originY, jReal* originZ, jInteger imageType);
	HITEM DS CreateItem(jInteger itemid, jReal* x, jReal* y);
	HITEMPOOL DS CreateItemPool();
	HLEADERBOARD DS CreateLeaderboard();
	HSOUND DS CreateMIDISound(jString soundLabel, jInteger fadeInRate, jInteger fadeOutRate);
	HMULTIBOARD DS CreateMultiboard();
	HQUEST DS CreateQuest();
	HREGION DS CreateRegion();
	HSOUND DS CreateSound(jString fileName, jBoolean looping, jBoolean is3D, jBoolean stopwhenoutofrange, jInteger fadeInRate, jInteger fadeOutRate, jString eaxSetting);
	HSOUND DS CreateSoundFilenameWithLabel(jString fileName, jBoolean looping, jBoolean is3D, jBoolean stopwhenoutofrange, jInteger fadeInRate, jInteger fadeOutRate, jString SLKEntryName);
	HSOUND DS CreateSoundFromLabel(jString soundLabel, jBoolean looping, jBoolean is3D, jBoolean stopwhenoutofrange, jInteger fadeInRate, jInteger fadeOutRate);
	HTEXTTAG DS CreateTextTag();
	HTIMER DS CreateTimer();
	HTIMERDIALOG DS CreateTimerDialog(HTIMER t);
	HTRACKABLE DS CreateTrackable(jString trackableModelPath, jReal* x, jReal* y, jReal* facing);
	jTrigger DS CreateTrigger();
	HUBERSPLAT DS CreateUbersplat(jReal* x, jReal* y, jString name, jInteger red, jInteger green, jInteger blue, jInteger alpha, jBoolean forcePaused, jBoolean noBirthTime);
	HUNIT DS CreateUnit(HPLAYER id, jInteger unitid, jReal* x, jReal* y, jReal* face);
	HUNIT DS CreateUnitAtLoc(HPLAYER id, jInteger unitid, HLOCATION whichLocation, jReal* face);
	HUNIT DS CreateUnitAtLocByName(HPLAYER id, jString unitname, HLOCATION whichLocation, jReal* face);
	HUNIT DS CreateUnitByName(HPLAYER whichPlayer, jString unitname, jReal* x, jReal* y, jReal* face);
	HUNITPOOL DS CreateUnitPool();
	jBoolean DS CreepsOnMap();
	jNothing DS CripplePlayer(HPLAYER whichPlayer, HFORCE toWhichPlayers, jBoolean flag);
	jNothing DS DebugBreak(jInteger arg1);
	jNothing DS DebugFI(jString arg1, jInteger arg2);
	jNothing DS DebugS(jString arg1);
	jNothing DS DebugUnitID(jString arg1, jInteger arg2);
	jInteger DS DecUnitAbilityLevel(HUNIT whichUnit, jInteger abilcode);
	jNothing DS DefeatConditionSetDescription(HDEFEATCONDITION whichCondition, jString description);
	jNothing DS DefineStartLocation(jInteger whichStartLoc, jReal* x, jReal* y);
	jNothing DS DefineStartLocationLoc(jInteger whichStartLoc, HLOCATION whichLocation);
	jReal DS Deg2Rad(jReal* degrees);
	jNothing DS DestroyBoolExpr(HBOOLEXPR e);
	jNothing DS DestroyCondition(HCONDITIONFUNC c);
	jNothing DS DestroyDefeatCondition(HDEFEATCONDITION whichCondition);
	jNothing DS DestroyEffect(HEFFECT whichEffect);
	jNothing DS DestroyFilter(HFILTERFUNC f);
	jNothing DS DestroyFogModifier(HFOGMODIFIER whichFogModifier);
	jNothing DS DestroyForce(HFORCE whichForce);
	jNothing DS DestroyGroup(HGROUP whichGroup);
	jNothing DS DestroyImage(HIMAGE whichImage);
	jNothing DS DestroyItemPool(HITEMPOOL whichItemPool);
	jNothing DS DestroyLeaderboard(HLEADERBOARD lb);
	jBoolean DS DestroyLightning(HLIGHTNING whichBolt);
	jNothing DS DestroyMultiboard(HMULTIBOARD lb);
	jNothing DS DestroyQuest(HQUEST whichQuest);
	jNothing DS DestroyTextTag(HTEXTTAG t);
	jNothing DS DestroyTimer(HTIMER whichTimer);
	jNothing DS DestroyTimerDialog(HTIMERDIALOG whichDialog);
	jNothing DS DestroyTrigger(jTrigger whichTrigger);
	jNothing DS DestroyUbersplat(HUBERSPLAT whichSplat);
	jNothing DS DestroyUnitPool(HUNITPOOL whichPool);
	jNothing DS DestructableRestoreLife(HDESTRUCTABLE d, jReal* life, jBoolean birth);
	HBUTTON DS DialogAddButton(HDIALOG whichDialog, jString buttonText, jInteger hotkey);
	HBUTTON DS DialogAddQuitButton(HDIALOG whichDialog, jBoolean doScoreScreen, jString buttonText, jInteger hotkey);
	jNothing DS DialogClear(HDIALOG whichDialog);
	HDIALOG DS DialogCreate();
	jNothing DS DialogDestroy(HDIALOG whichDialog);
	jNothing DS DialogDisplay(HPLAYER whichPlayer, HDIALOG whichDialog, jBoolean flag);
	jNothing DS DialogSetAsync(HDIALOG arg1);
	jNothing DS DialogSetMessage(HDIALOG whichDialog, jString messageText);
	jNothing DS DisablePathing();
	jNothing DS DisableRestartMission(jBoolean flag);
	jNothing DS DisableTrigger(jTrigger whichTrigger);
	jNothing DS DisplayCineFilter(jBoolean flag);
	jNothing DS DisplayLoadDialog();
	jNothing DS DisplayText(jInteger arg1, jString arg2);
	jNothing DS DisplayTextI(jInteger arg1, jString arg2, jInteger arg3);
	jNothing DS DisplayTextII(jInteger arg1, jString arg2, jInteger arg3, jInteger arg4);
	jNothing DS DisplayTextIII(jInteger arg1, jString arg2, jInteger arg3, jInteger arg4, jInteger arg5);
	jNothing DS DisplayTextToPlayer(HPLAYER toPlayer, jReal* x, jReal* y, jString msg);
	jNothing DS DisplayTimedTextFromPlayer(HPLAYER toPlayer, jReal* x, jReal* y, jReal* duration, jString msg);
	jNothing DS DisplayTimedTextToPlayer(HPLAYER toPlayer, jReal* x, jReal* y, jReal* duration, jString msg);
	jBoolean DS DoAiScriptDebug();
	jNothing DS DoNotSaveReplay();
	jNothing DS EnableDragSelect(jBoolean state, jBoolean ui);
	jNothing DS EnableMinimapFilterButtons(jBoolean enableAlly, jBoolean enableCreep);
	jNothing DS EnableOcclusion(jBoolean flag);
	jNothing DS EnablePreSelect(jBoolean state, jBoolean ui);
	jNothing DS EnableSelect(jBoolean state, jBoolean ui);
	jNothing DS EnableTrigger(jTrigger whichTrigger);
	jNothing DS EnableUserControl(jBoolean b);
	jNothing DS EnableUserUI(jBoolean b);
	jNothing DS EnableWeatherEffect(HWEATHEREFFECT whichEffect, jBoolean enable);
	jNothing DS EnableWorldFogBoundary(jBoolean b);
	jNothing DS EndCinematicScene();
	jNothing DS EndGame(jBoolean doScoreScreen);
	jNothing DS EndThematicMusic();
	jNothing DS EnumDestructablesInRect(HRECT r, HBOOLEXPR filter, jCode actionFunc);
	jNothing DS EnumItemsInRect(HRECT r, HBOOLEXPR filter, jCode actionFunc);
	jNothing DS ExecuteFunc(jString funcName);
	jNothing DS FillGuardPosts();
	HFILTERFUNC DS Filter(jCode func);
	jNothing DS FinishUbersplat(HUBERSPLAT whichSplat);
	HUNIT DS FirstOfGroup(HGROUP whichGroup);
	jNothing DS FlashQuestDialogButton();
	jNothing DS FlushChildHashtable(HHASHTABLE table, jInteger parentKey);
	jNothing DS FlushGameCache(HGAMECACHE cache);
	jNothing DS FlushParentHashtable(HHASHTABLE table);
	jNothing DS FlushStoredBoolean(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS FlushStoredInteger(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS FlushStoredMission(HGAMECACHE cache, jString missionKey);
	jNothing DS FlushStoredReal(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS FlushStoredString(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS FlushStoredUnit(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS FogEnable(jBoolean enable);
	jNothing DS FogMaskEnable(jBoolean enable);
	jNothing DS FogModifierStart(HFOGMODIFIER whichFogModifier);
	jNothing DS FogModifierStop(HFOGMODIFIER whichFogModifier);
	jNothing DS ForForce(HFORCE whichForce, jCode callback);
	jNothing DS ForGroup(HGROUP whichGroup, jCode callback);
	jNothing DS ForceAddPlayer(HFORCE whichForce, HPLAYER whichPlayer);
	jNothing DS ForceCampaignSelectScreen();
	jNothing DS ForceCinematicSubtitles(jBoolean flag);
	jNothing DS ForceClear(HFORCE whichForce);
	jNothing DS ForceEnumAllies(HFORCE whichForce, HPLAYER whichPlayer, HBOOLEXPR filter);
	jNothing DS ForceEnumEnemies(HFORCE whichForce, HPLAYER whichPlayer, HBOOLEXPR filter);
	jNothing DS ForceEnumPlayers(HFORCE whichForce, HBOOLEXPR filter);
	jNothing DS ForceEnumPlayersCounted(HFORCE whichForce, HBOOLEXPR filter, jInteger countLimit);
	jNothing DS ForcePlayerStartLocation(HPLAYER whichPlayer, jInteger startLocIndex);
	jNothing DS ForceQuestDialogUpdate();
	jNothing DS ForceRemovePlayer(HFORCE whichForce, HPLAYER whichPlayer);
	jNothing DS ForceUICancel();
	jNothing DS ForceUIKey(jString key);
	HAIDIFFICULTY DS GetAIDifficulty(HPLAYER num);
	jString DS GetAbilityEffect(jString abilityString, HEFFECTTYPE t, jInteger index);
	jString DS GetAbilityEffectById(jInteger abilityId, HEFFECTTYPE t, jInteger index);
	jString DS GetAbilitySound(jString abilityString, HSOUNDTYPE t);
	jString DS GetAbilitySoundById(jInteger abilityId, HSOUNDTYPE t);
	jInteger DS GetAiPlayer();
	HUNIT DS GetAllianceTarget();
	jInteger DS GetAllyColorFilterState();
	HUNIT DS GetAttacker();
	HUNIT DS GetBuilding(HPLAYER arg1);
	HUNIT DS GetBuyingUnit();
	jReal DS GetCameraBoundMaxX();
	jReal DS GetCameraBoundMaxY();
	jReal DS GetCameraBoundMinX();
	jReal DS GetCameraBoundMinY();
	HLOCATION DS GetCameraEyePositionLoc();
	jReal DS GetCameraEyePositionX();
	jReal DS GetCameraEyePositionY();
	jReal DS GetCameraEyePositionZ();
	jReal DS GetCameraField(HCAMERAFIELD whichField);
	jReal DS GetCameraMargin(jInteger whichMargin);
	HLOCATION DS GetCameraTargetPositionLoc();
	jReal DS GetCameraTargetPositionX();
	jReal DS GetCameraTargetPositionY();
	jReal DS GetCameraTargetPositionZ();
	HUNIT DS GetCancelledStructure();
	HUNIT DS GetChangingUnit();
	HPLAYER DS GetChangingUnitPrevOwner();
	HBUTTON DS GetClickedButton();
	HDIALOG DS GetClickedDialog();
	HUNIT DS GetConstructedStructure();
	HUNIT DS GetConstructingStructure();
	HMAPDENSITY DS GetCreatureDensity();
	HUNIT DS GetCreepCamp(jInteger arg1, jInteger arg2, jBoolean arg3);
	jBoolean DS GetCreepCampFilterState();
	jBoolean DS GetCustomCampaignButtonVisible(jInteger whichButton);
	HUNIT DS GetDecayingUnit();
	HGAMEDIFFICULTY DS GetDefaultDifficulty();
	jReal DS GetDestructableLife(HDESTRUCTABLE d);
	jReal DS GetDestructableMaxLife(HDESTRUCTABLE d);
	jString DS GetDestructableName(HDESTRUCTABLE d);
	jReal DS GetDestructableOccluderHeight(HDESTRUCTABLE d);
	jInteger DS GetDestructableTypeId(HDESTRUCTABLE d);
	jReal DS GetDestructableX(HDESTRUCTABLE d);
	jReal DS GetDestructableY(HDESTRUCTABLE d);
	HUNIT DS GetDetectedUnit();
	HUNIT DS GetDyingUnit();
	HUNIT DS GetEnemyBase();
	HUNIT DS GetEnemyExpansion();
	jInteger DS GetEnemyPower();
	HUNIT DS GetEnteringUnit();
	HDESTRUCTABLE DS GetEnumDestructable();
	HITEM DS GetEnumItem();
	HPLAYER DS GetEnumPlayer();
	HUNIT DS GetEnumUnit();
	jReal DS GetEventDamage();
	HUNIT DS GetEventDamageSource();
	HPLAYER DS GetEventDetectingPlayer();
	HGAMESTATE DS GetEventGameState();
	jString DS GetEventPlayerChatString();
	jString DS GetEventPlayerChatStringMatched();
	HPLAYERSTATE DS GetEventPlayerState();
	HUNIT DS GetEventTargetUnit();
	HUNITSTATE DS GetEventUnitState();
	HUNIT DS GetExpansionFoe();
	HUNIT DS GetExpansionPeon();
	jInteger DS GetExpansionX();
	jInteger DS GetExpansionY();
	HTIMER DS GetExpiredTimer();
	HDESTRUCTABLE DS GetFilterDestructable();
	HITEM DS GetFilterItem();
	HPLAYER DS GetFilterPlayer();
	HUNIT DS GetFilterUnit();
	jReal DS GetFloatGameState(HFGAMESTATE whichFloatGameState);
	jInteger DS GetFoodMade(jInteger unitId);
	jInteger DS GetFoodUsed(jInteger unitId);
	HGAMEDIFFICULTY DS GetGameDifficulty();
	HPLACEMENT DS GetGamePlacement();
	HGAMESPEED DS GetGameSpeed();
	HGAMETYPE DS GetGameTypeSelected();
	jInteger DS GetGoldOwned();
	jInteger DS GetHandleId(HHANDLE2 h);
	jInteger DS GetHeroAgi(HUNIT whichHero, jBoolean includeBonuses);
	jInteger DS GetHeroId();
	jInteger DS GetHeroInt(HUNIT whichHero, jBoolean includeBonuses);
	jInteger DS GetHeroLevel(HUNIT whichHero);
	jInteger DS GetHeroLevelAI();
	jString DS GetHeroProperName(HUNIT whichHero);
	jInteger DS GetHeroSkillPoints(HUNIT whichHero);
	jInteger DS GetHeroStr(HUNIT whichHero, jBoolean includeBonuses);
	jInteger DS GetHeroXP(HUNIT whichHero);
	jInteger DS GetIntegerGameState(HIGAMESTATE whichIntegerGameState);
	jInteger DS GetIssuedOrderId();
	jInteger DS GetItemCharges(HITEM whichItem);
	jInteger DS GetItemLevel(HITEM whichItem);
	jString DS GetItemName(HITEM whichItem);
	HPLAYER DS GetItemPlayer(HITEM whichItem);
	HITEMTYPE DS GetItemType(HITEM whichItem);
	jInteger DS GetItemTypeId(HITEM i);
	jInteger DS GetItemUserData(HITEM whichItem);
	jReal DS GetItemX(HITEM i);
	jReal DS GetItemY(HITEM i);
	HUNIT DS GetKillingUnit();
	jInteger DS GetLastCommand();
	jInteger DS GetLastData();
	jInteger DS GetLearnedSkill();
	jInteger DS GetLearnedSkillLevel();
	HUNIT DS GetLearningUnit();
	HUNIT DS GetLeavingUnit();
	HUNIT DS GetLevelingUnit();
	jReal DS GetLightningColorA(HLIGHTNING whichBolt);
	jReal DS GetLightningColorB(HLIGHTNING whichBolt);
	jReal DS GetLightningColorG(HLIGHTNING whichBolt);
	jReal DS GetLightningColorR(HLIGHTNING whichBolt);
	HUNIT DS GetLoadedUnit();
	HPLAYER DS GetLocalPlayer();
	jInteger DS GetLocalizedHotkey(jString source);
	jString DS GetLocalizedString(jString source);
	jReal DS GetLocationX(HLOCATION whichLocation);
	jReal DS GetLocationY(HLOCATION whichLocation);
	jReal DS GetLocationZ(HLOCATION whichLocation);
	HITEM DS GetManipulatedItem();
	HUNIT DS GetManipulatingUnit();
	HUNIT DS GetMegaTarget();
	jInteger DS GetMinesOwned();
	jInteger DS GetNextExpansion();
	jString DS GetObjectName(jInteger objectId);
	HLOCATION DS GetOrderPointLoc();
	jReal DS GetOrderPointX();
	jReal DS GetOrderPointY();
	HWIDGET DS GetOrderTarget();
	HDESTRUCTABLE DS GetOrderTargetDestructable();
	HITEM DS GetOrderTargetItem();
	HUNIT DS GetOrderTargetUnit();
	HUNIT DS GetOrderedUnit();
	HPLAYER DS GetOwningPlayer(HUNIT whichUnit);
	jBoolean DS GetPlayerAlliance(HPLAYER sourcePlayer, HPLAYER otherPlayer, HALLIANCETYPE whichAllianceSetting);
	HPLAYERCOLOR DS GetPlayerColor(HPLAYER whichPlayer);
	HMAPCONTROL DS GetPlayerController(HPLAYER whichPlayer);
	jReal DS GetPlayerHandicap(HPLAYER whichPlayer);
	jReal DS GetPlayerHandicapXP(HPLAYER whichPlayer);
	jInteger DS GetPlayerId(HPLAYER whichPlayer);
	jString DS GetPlayerName(HPLAYER whichPlayer);
	HRACE DS GetPlayerRace(HPLAYER whichPlayer);
	jInteger DS GetPlayerScore(HPLAYER whichPlayer, HPLAYERSCORE whichPlayerScore);
	jBoolean DS GetPlayerSelectable(HPLAYER whichPlayer);
	HPLAYERSLOTSTATE DS GetPlayerSlotState(HPLAYER whichPlayer);
	jInteger DS GetPlayerStartLocation(HPLAYER whichPlayer);
	jReal DS GetPlayerStartLocationX(HPLAYER arg1);
	jReal DS GetPlayerStartLocationY(HPLAYER arg1);
	jInteger DS GetPlayerState(HPLAYER whichPlayer, HPLAYERSTATE whichPlayerState);
	jInteger DS GetPlayerStructureCount(HPLAYER whichPlayer, jBoolean includeIncomplete);
	jInteger DS GetPlayerTaxRate(HPLAYER sourcePlayer, HPLAYER otherPlayer, HPLAYERSTATE whichResource);
	jInteger DS GetPlayerTeam(HPLAYER whichPlayer);
	jInteger DS GetPlayerTechCount(HPLAYER whichPlayer, jInteger techid, jBoolean specificonly);
	jInteger DS GetPlayerTechMaxAllowed(HPLAYER whichPlayer, jInteger techid);
	jBoolean DS GetPlayerTechResearched(HPLAYER whichPlayer, jInteger techid, jBoolean specificonly);
	jInteger DS GetPlayerTypedUnitCount(HPLAYER whichPlayer, jString unitName, jBoolean includeIncomplete, jBoolean includeUpgrades);
	jInteger DS GetPlayerUnitCount(HPLAYER whichPlayer, jBoolean includeIncomplete);
	jInteger DS GetPlayerUnitTypeCount(HPLAYER arg1, jInteger arg2);
	jInteger DS GetPlayers();
	jInteger DS GetRandomInt(jInteger lowBound, jInteger highBound);
	jReal DS GetRandomReal(jReal* lowBound, jReal* highBound);
	jReal DS GetRectCenterX(HRECT whichRect);
	jReal DS GetRectCenterY(HRECT whichRect);
	jReal DS GetRectMaxX(HRECT whichRect);
	jReal DS GetRectMaxY(HRECT whichRect);
	jReal DS GetRectMinX(HRECT whichRect);
	jReal DS GetRectMinY(HRECT whichRect);
	HUNIT DS GetRescuer();
	jInteger DS GetResearched();
	HUNIT DS GetResearchingUnit();
	jInteger DS GetResourceAmount(HUNIT whichUnit);
	HMAPDENSITY DS GetResourceDensity();
	HUNIT DS GetRevivableUnit();
	HUNIT DS GetRevivingUnit();
	jString DS GetSaveBasicFilename();
	HUNIT DS GetSellingUnit();
	HITEM DS GetSoldItem();
	HUNIT DS GetSoldUnit();
	jInteger DS GetSoundDuration(HSOUND soundHandle);
	jInteger DS GetSoundFileDuration(jString musicFileName);
	jBoolean DS GetSoundIsLoading(HSOUND soundHandle);
	jBoolean DS GetSoundIsPlaying(HSOUND soundHandle);
	HABILITY DS GetSpellAbility();
	jInteger DS GetSpellAbilityId();
	HUNIT GetSpellAbilityUnit();
	HDESTRUCTABLE DS GetSpellTargetDestructable();
	HITEM DS GetSpellTargetItem();
	HLOCATION DS GetSpellTargetLoc();
	HUNIT DS GetSpellTargetUnit();
	jReal DS GetSpellTargetX();
	jReal DS GetSpellTargetY();
	HSTARTLOCPRIO DS GetStartLocPrio(jInteger whichStartLoc, jInteger prioSlotIndex);
	jInteger DS GetStartLocPrioSlot(jInteger whichStartLoc, jInteger prioSlotIndex);
	HLOCATION DS GetStartLocationLoc(jInteger whichStartLocation);
	jReal DS GetStartLocationX(jInteger whichStartLocation);
	jReal DS GetStartLocationY(jInteger whichStartLocation);
	jBoolean DS GetStoredBoolean(HGAMECACHE cache, jString missionKey, jString key);
	jInteger DS GetStoredInteger(HGAMECACHE cache, jString missionKey, jString key);
	jReal DS GetStoredReal(HGAMECACHE cache, jString missionKey, jString key);
	jString DS GetStoredString(HGAMECACHE cache, jString missionKey, jString key);
	HUNIT DS GetSummonedUnit();
	HUNIT DS GetSummoningUnit();
	jInteger DS GetTeams();
	jInteger DS GetTerrainCliffLevel(jReal* x, jReal* y);
	jInteger DS GetTerrainType(jReal* x, jReal* y);
	jInteger DS GetTerrainVariance(jReal* x, jReal* y);
	jReal DS GetTimeOfDayScale();
	HPLAYER DS GetTournamentFinishNowPlayer();
	jInteger DS GetTournamentFinishNowRule();
	jReal DS GetTournamentFinishSoonTimeRemaining();
	jInteger DS GetTournamentScore(HPLAYER whichPlayer);
	jInteger DS GetTownUnitCount(jInteger arg1, jInteger arg2, jBoolean arg3);
	HUNIT DS GetTrainedUnit();
	jInteger DS GetTrainedUnitType();
	HUNIT DS GetTransportUnit();
	HDESTRUCTABLE DS GetTriggerDestructable();
	jInteger DS GetTriggerEvalCount(jTrigger whichTrigger);
	HEVENTID DS GetTriggerEventId();
	jInteger DS GetTriggerExecCount(jTrigger whichTrigger);
	HPLAYER DS GetTriggerPlayer();
	HUNIT DS GetTriggerUnit();
	HWIDGET DS GetTriggerWidget();
	HREGION DS GetTriggeringRegion();
	HTRACKABLE DS GetTriggeringTrackable();
	jTrigger DS GetTriggeringTrigger();
	jInteger DS GetUnitAbilityLevel(HUNIT whichUnit, jInteger abilcode);
	jReal DS GetUnitAcquireRange(HUNIT whichUnit);
	jInteger DS GetUnitBuildTime(jInteger arg1);
	jInteger DS GetUnitCount(jInteger arg1);
	jInteger DS GetUnitCountDone(jInteger arg1);
	jInteger DS GetUnitCurrentOrder(HUNIT whichUnit);
	jReal DS GetUnitDefaultAcquireRange(HUNIT whichUnit);
	jReal DS GetUnitDefaultFlyHeight(HUNIT whichUnit);
	jReal DS GetUnitDefaultMoveSpeed(HUNIT whichUnit);
	jReal DS GetUnitDefaultPropWindow(HUNIT whichUnit);
	jReal DS GetUnitDefaultTurnSpeed(HUNIT whichUnit);
	jReal DS GetUnitFacing(HUNIT whichUnit);
	jReal DS GetUnitFlyHeight(HUNIT whichUnit);
	jInteger DS GetUnitFoodMade(HUNIT whichUnit);
	jInteger DS GetUnitFoodUsed(HUNIT whichUnit);
	jInteger DS GetUnitGoldCost(jInteger arg1);
	jInteger DS GetUnitLevel(HUNIT whichUnit);
	HLOCATION DS GetUnitLoc(HUNIT whichUnit);
	jReal DS GetUnitMoveSpeed(HUNIT whichUnit);
	jString DS GetUnitName(HUNIT whichUnit);
	jInteger DS GetUnitPointValue(HUNIT whichUnit);
	jInteger DS GetUnitPointValueByType(jInteger unitType);
	jReal DS GetUnitPropWindow(HUNIT whichUnit);
	HRACE DS GetUnitRace(HUNIT whichUnit);
	HDESTRUCTABLE DS GetUnitRallyDestructable(HUNIT whichUnit);
	HLOCATION DS GetUnitRallyPoint(HUNIT whichUnit);
	HUNIT DS GetUnitRallyUnit(HUNIT whichUnit);
	jReal DS GetUnitState(HUNIT whichUnit, HUNITSTATE whichUnitState);
	jReal DS GetUnitTurnSpeed(HUNIT whichUnit);
	jInteger DS GetUnitTypeId(HUNIT whichUnit);
	jInteger DS GetUnitUserData(HUNIT whichUnit);
	jInteger DS GetUnitWoodCost(jInteger arg1);
	jReal DS GetUnitX(HUNIT whichUnit);
	jReal DS GetUnitY(HUNIT whichUnit);
	jInteger DS GetUpgradeGoldCost(jInteger arg1);
	jInteger DS GetUpgradeLevel(jInteger arg1);
	jInteger DS GetUpgradeWoodCost(jInteger arg1);
	jReal DS GetWidgetLife(HWIDGET whichWidget);
	jReal DS GetWidgetX(HWIDGET whichWidget);
	jReal DS GetWidgetY(HWIDGET whichWidget);
	HPLAYER DS GetWinningPlayer();
	HRECT DS GetWorldBounds();
	jNothing DS GroupAddUnit(HGROUP whichGroup, HUNIT whichUnit);
	jNothing DS GroupClear(HGROUP whichGroup);
	jNothing DS GroupEnumUnitsInRange(HGROUP whichGroup, jReal* x, jReal* y, jReal* radius, HBOOLEXPR filter);
	jNothing DS GroupEnumUnitsInRangeCounted(HGROUP whichGroup, jReal* x, jReal* y, jReal* radius, HBOOLEXPR filter, jInteger countLimit);
	jNothing DS GroupEnumUnitsInRangeOfLoc(HGROUP whichGroup, HLOCATION whichLocation, jReal* radius, HBOOLEXPR filter);
	jNothing DS GroupEnumUnitsInRangeOfLocCounted(HGROUP whichGroup, HLOCATION whichLocation, jReal* radius, HBOOLEXPR filter, jInteger countLimit);
	jNothing DS GroupEnumUnitsInRect(HGROUP whichGroup, HRECT r, HBOOLEXPR filter);
	jNothing DS GroupEnumUnitsInRectCounted(HGROUP whichGroup, HRECT r, HBOOLEXPR filter, jInteger countLimit);
	jNothing DS GroupEnumUnitsOfPlayer(HGROUP whichGroup, HPLAYER whichPlayer, HBOOLEXPR filter);
	jNothing DS GroupEnumUnitsOfType(HGROUP whichGroup, jString unitname, HBOOLEXPR filter);
	jNothing DS GroupEnumUnitsOfTypeCounted(HGROUP whichGroup, jString unitname, HBOOLEXPR filter, jInteger countLimit);
	jNothing DS GroupEnumUnitsSelected(HGROUP whichGroup, HPLAYER whichPlayer, HBOOLEXPR filter);
	jBoolean DS GroupImmediateOrder(HGROUP whichGroup, jString order);
	jBoolean DS GroupImmediateOrderById(HGROUP whichGroup, jInteger order);
	jBoolean DS GroupPointOrder(HGROUP whichGroup, jString order, jReal* x, jReal* y);
	jBoolean DS GroupPointOrderById(HGROUP whichGroup, jInteger order, jReal* x, jReal* y);
	jBoolean DS GroupPointOrderByIdLoc(HGROUP whichGroup, jInteger order, HLOCATION whichLocation);
	jBoolean DS GroupPointOrderLoc(HGROUP whichGroup, jString order, HLOCATION whichLocation);
	jNothing DS GroupRemoveUnit(HGROUP whichGroup, HUNIT whichUnit);
	jBoolean DS GroupTargetOrder(HGROUP whichGroup, jString order, HWIDGET targetWidget);
	jBoolean DS GroupTargetOrderById(HGROUP whichGroup, jInteger order, HWIDGET targetWidget);
	jNothing DS GroupTimedLife(jBoolean arg1);
	jNothing DS HarvestGold(jInteger arg1, jInteger arg2);
	jNothing DS HarvestWood(jInteger arg1, jInteger arg2);
	jBoolean DS HaveSavedBoolean(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS HaveSavedHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS HaveSavedInteger(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS HaveSavedReal(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS HaveSavedString(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS HaveStoredBoolean(HGAMECACHE cache, jString missionKey, jString key);
	jBoolean DS HaveStoredInteger(HGAMECACHE cache, jString missionKey, jString key);
	jBoolean DS HaveStoredReal(HGAMECACHE cache, jString missionKey, jString key);
	jBoolean DS HaveStoredString(HGAMECACHE cache, jString missionKey, jString key);
	jBoolean DS HaveStoredUnit(HGAMECACHE cache, jString missionKey, jString key);
	jReal DS I2R(jInteger i);
	jString DS I2S(jInteger i);
	jInteger DS IgnoredUnits(jInteger arg1);
	jInteger DS IncUnitAbilityLevel(HUNIT whichUnit, jInteger abilcode);
	jNothing DS InitAssault();
	HGAMECACHE DS InitGameCache(jString campaignFile);
	HHASHTABLE DS InitHashtable();
	jBoolean DS IsCineFilterDisplayed();
	jBoolean DS IsDestructableInvulnerable(HDESTRUCTABLE d);
	jBoolean DS IsFogEnabled();
	jBoolean DS IsFogMaskEnabled();
	jBoolean DS IsFoggedToPlayer(jReal* x, jReal* y, HPLAYER whichPlayer);
	jBoolean DS IsGameTypeSupported(HGAMETYPE whichGameType);
	jBoolean DS IsHeroUnitId(jInteger unitId);
	jBoolean DS IsItemIdPawnable(jInteger itemId);
	jBoolean DS IsItemIdPowerup(jInteger itemId);
	jBoolean DS IsItemIdSellable(jInteger itemId);
	jBoolean DS IsItemInvulnerable(HITEM whichItem);
	jBoolean DS IsItemOwned(HITEM whichItem);
	jBoolean DS IsItemPawnable(HITEM whichItem);
	jBoolean DS IsItemPowerup(HITEM whichItem);
	jBoolean DS IsItemSellable(HITEM whichItem);
	jBoolean DS IsItemVisible(HITEM whichItem);
	jBoolean DS IsLeaderboardDisplayed(HLEADERBOARD lb);
	jBoolean DS IsLocationFoggedToPlayer(HLOCATION whichLocation, HPLAYER whichPlayer);
	jBoolean DS IsLocationInRegion(HREGION whichRegion, HLOCATION whichLocation);
	jBoolean DS IsLocationMaskedToPlayer(HLOCATION whichLocation, HPLAYER whichPlayer);
	jBoolean DS IsLocationVisibleToPlayer(HLOCATION whichLocation, HPLAYER whichPlayer);
	jBoolean DS IsMapFlagSet(HMAPFLAG whichMapFlag);
	jBoolean DS IsMaskedToPlayer(jReal* x, jReal* y, HPLAYER whichPlayer);
	jBoolean DS IsMultiboardDisplayed(HMULTIBOARD lb);
	jBoolean DS IsMultiboardMinimized(HMULTIBOARD lb);
	jBoolean DS IsNoDefeatCheat();
	jBoolean DS IsNoVictoryCheat();
	jBoolean DS IsPlayerAlly(HPLAYER whichPlayer, HPLAYER otherPlayer);
	jBoolean DS IsPlayerEnemy(HPLAYER whichPlayer, HPLAYER otherPlayer);
	jBoolean DS IsPlayerInForce(HPLAYER whichPlayer, HFORCE whichForce);
	jBoolean DS IsPlayerObserver(HPLAYER whichPlayer);
	jBoolean DS IsPlayerRacePrefSet(HPLAYER whichPlayer, HRACEPREFERENCE pref);
	jBoolean DS IsPointBlighted(jReal* x, jReal* y);
	jBoolean DS IsPointInRegion(HREGION whichRegion, jReal* x, jReal* y);
	jBoolean DS IsQuestCompleted(HQUEST whichQuest);
	jBoolean DS IsQuestDiscovered(HQUEST whichQuest);
	jBoolean DS IsQuestEnabled(HQUEST whichQuest);
	jBoolean DS IsQuestFailed(HQUEST whichQuest);
	jBoolean DS IsQuestItemCompleted(HQUESTITEM whichQuestItem);
	jBoolean DS IsQuestRequired(HQUEST whichQuest);
	jBoolean DS IsSuspendedXP(HUNIT whichHero);
	jBoolean DS IsTerrainPathable(jReal* x, jReal* y, HPATHINGTYPE t);
	jBoolean DS IsTimerDialogDisplayed(HTIMERDIALOG whichDialog);
	jBoolean DS IsTowered(HUNIT arg1);
	jBoolean DS IsTriggerEnabled(jTrigger whichTrigger);
	jBoolean DS IsTriggerWaitOnSleeps(jTrigger whichTrigger);
	jBoolean DS IsUnit(HUNIT whichUnit, HUNIT whichSpecifiedUnit);
	jBoolean DS IsUnitAlly(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitDetected(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitEnemy(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitFogged(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitHidden(HUNIT whichUnit);
	jBoolean DS IsUnitIdType(jInteger unitId, HUNITTYPE whichUnitType);
	jBoolean DS IsUnitIllusion(HUNIT whichUnit);
	jBoolean DS IsUnitInForce(HUNIT whichUnit, HFORCE whichForce);
	jBoolean DS IsUnitInGroup(HUNIT whichUnit, HGROUP whichGroup);
	jBoolean DS IsUnitInRange(HUNIT whichUnit, HUNIT otherUnit, jReal* distance);
	jBoolean DS IsUnitInRangeLoc(HUNIT whichUnit, HLOCATION whichLocation, jReal* distance);
	jBoolean DS IsUnitInRangeXY(HUNIT whichUnit, jReal* x, jReal* y, jReal* distance);
	jBoolean DS IsUnitInRegion(HREGION whichRegion, HUNIT whichUnit);
	jBoolean DS IsUnitInTransport(HUNIT whichUnit, HUNIT whichTransport);
	jBoolean DS IsUnitInvisible(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitLoaded(HUNIT whichUnit);
	jBoolean DS IsUnitMasked(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitOwnedByPlayer(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitPaused(HUNIT whichHero);
	jBoolean DS IsUnitRace(HUNIT whichUnit, HRACE whichRace);
	jBoolean DS IsUnitSelected(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsUnitType(HUNIT whichUnit, HUNITTYPE whichUnitType);
	jBoolean DS IsUnitVisible(HUNIT whichUnit, HPLAYER whichPlayer);
	jBoolean DS IsVisibleToPlayer(jReal* x, jReal* y, HPLAYER whichPlayer);
	jBoolean DS IssueBuildOrder(HUNIT whichPeon, jString unitToBuild, jReal* x, jReal* y);
	jBoolean DS IssueBuildOrderById(HUNIT whichPeon, jInteger unitId, jReal* x, jReal* y);
	jBoolean DS IssueImmediateOrder(HUNIT whichUnit, jString order);
	jBoolean DS IssueImmediateOrderById(HUNIT whichUnit, jInteger order);
	jBoolean DS IssueInstantPointOrder(HUNIT whichUnit, jString order, jReal* x, jReal* y, HWIDGET instantTargetWidget);
	jBoolean DS IssueInstantPointOrderById(HUNIT whichUnit, jInteger order, jReal* x, jReal* y, HWIDGET instantTargetWidget);
	jBoolean DS IssueInstantTargetOrder(HUNIT whichUnit, jString order, HWIDGET targetWidget, HWIDGET instantTargetWidget);
	jBoolean DS IssueInstantTargetOrderById(HUNIT whichUnit, jInteger order, HWIDGET targetWidget, HWIDGET instantTargetWidget);
	jBoolean DS IssueNeutralImmediateOrder(HPLAYER forWhichPlayer, HUNIT neutralStructure, jString unitToBuild);
	jBoolean DS IssueNeutralImmediateOrderById(HPLAYER forWhichPlayer, HUNIT neutralStructure, jInteger unitId);
	jBoolean DS IssueNeutralPointOrder(HPLAYER forWhichPlayer, HUNIT neutralStructure, jString unitToBuild, jReal* x, jReal* y);
	jBoolean DS IssueNeutralPointOrderById(HPLAYER forWhichPlayer, HUNIT neutralStructure, jInteger unitId, jReal* x, jReal* y);
	jBoolean DS IssueNeutralTargetOrder(HPLAYER forWhichPlayer, HUNIT neutralStructure, jString unitToBuild, HWIDGET target);
	jBoolean DS IssueNeutralTargetOrderById(HPLAYER forWhichPlayer, HUNIT neutralStructure, jInteger unitId, HWIDGET target);
	jBoolean DS IssuePointOrder(HUNIT whichUnit, jString order, jReal* x, jReal* y);
	jBoolean DS IssuePointOrderById(HUNIT whichUnit, jInteger order, jReal* x, jReal* y);
	jBoolean DS IssuePointOrderByIdLoc(HUNIT whichUnit, jInteger order, HLOCATION whichLocation);
	jBoolean DS IssuePointOrderLoc(HUNIT whichUnit, jString order, HLOCATION whichLocation);
	jBoolean DS IssueTargetOrder(HUNIT whichUnit, jString order, HWIDGET targetWidget);
	jBoolean DS IssueTargetOrderById(HUNIT whichUnit, jInteger order, HWIDGET targetWidget);
	jNothing DS ItemPoolAddItemType(HITEMPOOL whichItemPool, jInteger itemId, jReal* weight);
	jNothing DS ItemPoolRemoveItemType(HITEMPOOL whichItemPool, jInteger itemId);
	jNothing DS KillDestructable(HDESTRUCTABLE d);
	jNothing DS KillSoundWhenDone(HSOUND soundHandle);
	jNothing DS KillUnit(HUNIT whichUnit);
	jNothing DS LeaderboardAddItem(HLEADERBOARD lb, jString label, jInteger value, HPLAYER p);
	jNothing DS LeaderboardClear(HLEADERBOARD lb);
	jNothing DS LeaderboardDisplay(HLEADERBOARD lb, jBoolean show);
	jInteger DS LeaderboardGetItemCount(HLEADERBOARD lb);
	jString DS LeaderboardGetLabelText(HLEADERBOARD lb);
	jInteger DS LeaderboardGetPlayerIndex(HLEADERBOARD lb, HPLAYER p);
	jBoolean DS LeaderboardHasPlayerItem(HLEADERBOARD lb, HPLAYER p);
	jNothing DS LeaderboardRemoveItem(HLEADERBOARD lb, jInteger index);
	jNothing DS LeaderboardRemovePlayerItem(HLEADERBOARD lb, HPLAYER p);
	jNothing DS LeaderboardSetItemLabel(HLEADERBOARD lb, jInteger whichItem, jString val);
	jNothing DS LeaderboardSetItemLabelColor(HLEADERBOARD lb, jInteger whichItem, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS LeaderboardSetItemStyle(HLEADERBOARD lb, jInteger whichItem, jBoolean showLabel, jBoolean showValue, jBoolean showIcon);
	jNothing DS LeaderboardSetItemValue(HLEADERBOARD lb, jInteger whichItem, jInteger val);
	jNothing DS LeaderboardSetItemValueColor(HLEADERBOARD lb, jInteger whichItem, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS LeaderboardSetLabel(HLEADERBOARD lb, jString label);
	jNothing DS LeaderboardSetLabelColor(HLEADERBOARD lb, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS LeaderboardSetSizeByItemCount(HLEADERBOARD lb, jInteger count);
	jNothing DS LeaderboardSetStyle(HLEADERBOARD lb, jBoolean showLabel, jBoolean showNames, jBoolean showValues, jBoolean showIcons);
	jNothing DS LeaderboardSetValueColor(HLEADERBOARD lb, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS LeaderboardSortItemsByLabel(HLEADERBOARD lb, jBoolean ascending);
	jNothing DS LeaderboardSortItemsByPlayer(HLEADERBOARD lb, jBoolean ascending);
	jNothing DS LeaderboardSortItemsByValue(HLEADERBOARD lb, jBoolean ascending);
	HABILITY DS LoadAbilityHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jBoolean DS LoadBoolean(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HBOOLEXPR DS LoadBooleanExprHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HBUTTON DS LoadButtonHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HDEFEATCONDITION DS LoadDefeatConditionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HDESTRUCTABLE DS LoadDestructableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HDIALOG DS LoadDialogHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HEFFECT DS LoadEffectHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HFOGMODIFIER DS LoadFogModifierHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HFOGSTATE DS LoadFogStateHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HFORCE DS LoadForceHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS LoadGame(jString saveFileName, jBoolean doScoreScreen);
	HGROUP DS LoadGroupHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HHASHTABLE DS LoadHashtableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HIMAGE DS LoadImageHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jInteger DS LoadInteger(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HITEM DS LoadItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HITEMPOOL DS LoadItemPoolHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HLEADERBOARD DS LoadLeaderboardHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HLIGHTNING DS LoadLightningHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HLOCATION DS LoadLocationHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HMULTIBOARD DS LoadMultiboardHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HMULTIBOARDITEM DS LoadMultiboardItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HPLAYER DS LoadPlayerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HQUEST DS LoadQuestHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HQUESTITEM DS LoadQuestItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jReal DS LoadReal(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HRECT DS LoadRectHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HREGION DS LoadRegionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HSOUND DS LoadSoundHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jString DS LoadStr(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTEXTTAG DS LoadTextTagHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTIMERDIALOG DS LoadTimerDialogHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTIMER DS LoadTimerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTRACKABLE DS LoadTrackableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTRIGGERACTION DS LoadTriggerActionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HTRIGGERCONDITION DS LoadTriggerConditionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HEVENT DS LoadTriggerEventHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jTrigger DS LoadTriggerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HUBERSPLAT DS LoadUbersplatHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HUNIT DS LoadUnitHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HUNITPOOL DS LoadUnitPoolHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	HWIDGET DS LoadWidgetHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS LoadZepWave(jInteger arg1, jInteger arg2);
	HLOCATION DS Location(jReal* x, jReal* y);
	jInteger DS MeleeDifficulty();
	jBoolean DS MergeUnits(jInteger arg1, jInteger arg2, jInteger arg3, jInteger arg4);
	jBoolean DS MoveLightning(HLIGHTNING whichBolt, jBoolean checkVisibility, jReal* x1, jReal* y1, jReal* x2, jReal* y2);
	jBoolean DS MoveLightningEx(HLIGHTNING whichBolt, jBoolean checkVisibility, jReal* x1, jReal* y1, jReal* z1, jReal* x2, jReal* y2, jReal* z2);
	jNothing DS MoveLocation(HLOCATION whichLocation, jReal* newX, jReal* newY);
	jNothing DS MoveRectTo(HRECT whichRect, jReal* newCenterX, jReal* newCenterY);
	jNothing DS MoveRectToLoc(HRECT whichRect, HLOCATION newCenterLoc);
	jNothing DS MultiboardClear(HMULTIBOARD lb);
	jNothing DS MultiboardDisplay(HMULTIBOARD lb, jBoolean show);
	jInteger DS MultiboardGetColumnCount(HMULTIBOARD lb);
	HMULTIBOARDITEM DS MultiboardGetItem(HMULTIBOARD lb, jInteger row, jInteger column);
	jInteger DS MultiboardGetRowCount(HMULTIBOARD lb);
	jString DS MultiboardGetTitleText(HMULTIBOARD lb);
	jNothing DS MultiboardMinimize(HMULTIBOARD lb, jBoolean minimize);
	jNothing DS MultiboardReleaseItem(HMULTIBOARDITEM mbi);
	jNothing DS MultiboardSetColumnCount(HMULTIBOARD lb, jInteger count);
	jNothing DS MultiboardSetItemIcon(HMULTIBOARDITEM mbi, jString iconFileName);
	jNothing DS MultiboardSetItemStyle(HMULTIBOARDITEM mbi, jBoolean showValue, jBoolean showIcon);
	jNothing DS MultiboardSetItemValue(HMULTIBOARDITEM mbi, jString val);
	jNothing DS MultiboardSetItemValueColor(HMULTIBOARDITEM mbi, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS MultiboardSetItemWidth(HMULTIBOARDITEM mbi, jReal* width);
	jNothing DS MultiboardSetItemsIcon(HMULTIBOARD lb, jString iconPath);
	jNothing DS MultiboardSetItemsStyle(HMULTIBOARD lb, jBoolean showValues, jBoolean showIcons);
	jNothing DS MultiboardSetItemsValue(HMULTIBOARD lb, jString value);
	jNothing DS MultiboardSetItemsValueColor(HMULTIBOARD lb, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS MultiboardSetItemsWidth(HMULTIBOARD lb, jReal* width);
	jNothing DS MultiboardSetRowCount(HMULTIBOARD lb, jInteger count);
	jNothing DS MultiboardSetTitleText(HMULTIBOARD lb, jString label);
	jNothing DS MultiboardSetTitleTextColor(HMULTIBOARD lb, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS MultiboardSuppressDisplay(jBoolean flag);
	jNothing DS NewSoundEnvironment(jString environmentName);
	HBOOLEXPR DS Not(HBOOLEXPR operand);
	HBOOLEXPR DS Or(HBOOLEXPR operandA, HBOOLEXPR operandB);
	jInteger DS OrderId(jString orderIdString);
	jString DS OrderId2String(jInteger orderId);
	jNothing DS PanCameraTo(jReal* x, jReal* y);
	jNothing DS PanCameraToTimed(jReal* x, jReal* y, jReal* duration);
	jNothing DS PanCameraToTimedWithZ(jReal* x, jReal* y, jReal* zOffsetDest, jReal* duration);
	jNothing DS PanCameraToWithZ(jReal* x, jReal* y, jReal* zOffsetDest);
	jNothing DS PauseCompAI(HPLAYER p, jBoolean pause);
	jNothing DS PauseGame(jBoolean flag);
	jNothing DS PauseTimer(HTIMER whichTimer);
	jNothing DS PauseUnit(HUNIT whichUnit, jBoolean flag);
	jNothing DS PingMinimap(jReal* x, jReal* y, jReal* duration);
	jNothing DS PingMinimapEx(jReal* x, jReal* y, jReal* duration, jInteger red, jInteger green, jInteger blue, jBoolean extraEffects);
	HITEM DS PlaceRandomItem(HITEMPOOL whichItemPool, jReal* x, jReal* y);
	HUNIT DS PlaceRandomUnit(HUNITPOOL whichPool, HPLAYER forWhichPlayer, jReal* x, jReal* y, jReal* facing);
	jNothing DS PlayCinematic(jString movieName);
	jNothing DS PlayModelCinematic(jString modelName);
	jNothing DS PlayMusic(jString musicName);
	jNothing DS PlayMusicEx(jString musicName, jInteger frommsecs, jInteger fadeinmsecs);
	jNothing DS PlayThematicMusic(jString musicFileName);
	jNothing DS PlayThematicMusicEx(jString musicFileName, jInteger frommsecs);
	HPLAYER DS Player(jInteger number);
	HLEADERBOARD DS PlayerGetLeaderboard(HPLAYER toPlayer);
	jNothing DS PlayerSetLeaderboard(HPLAYER toPlayer, HLEADERBOARD lb);
	jNothing DS PopLastCommand();
	jReal DS Pow(jReal* x, jReal* power);
	jNothing DS Preload(jString filename);
	jNothing DS PreloadEnd(jReal* timeout);
	jNothing DS PreloadEndEx();
	jNothing DS PreloadGenClear();
	jNothing DS PreloadGenEnd(jString filename);
	jNothing DS PreloadGenStart();
	jNothing DS PreloadRefresh();
	jNothing DS PreloadStart();
	jNothing DS Preloader(jString filename);
	jNothing DS PurchaseZeppelin();
	HQUESTITEM DS QuestCreateItem(HQUEST whichQuest);
	jNothing DS QuestItemSetCompleted(HQUESTITEM whichQuestItem, jBoolean completed);
	jNothing DS QuestItemSetDescription(HQUESTITEM whichQuestItem, jString description);
	jNothing DS QuestSetCompleted(HQUEST whichQuest, jBoolean completed);
	jNothing DS QuestSetDescription(HQUEST whichQuest, jString description);
	jNothing DS QuestSetDiscovered(HQUEST whichQuest, jBoolean discovered);
	jNothing DS QuestSetEnabled(HQUEST whichQuest, jBoolean enabled);
	jNothing DS QuestSetFailed(HQUEST whichQuest, jBoolean failed);
	jNothing DS QuestSetIconPath(HQUEST whichQuest, jString iconPath);
	jNothing DS QuestSetRequired(HQUEST whichQuest, jBoolean required);
	jNothing DS QuestSetTitle(HQUEST whichQuest, jString title);
	jNothing DS QueueDestructableAnimation(HDESTRUCTABLE d, jString whichAnimation);
	jNothing DS QueueUnitAnimation(HUNIT whichUnit, jString whichAnimation);
	jInteger DS R2I(jReal* r);
	jString DS R2S(jReal* r);
	jString DS R2SW(jReal* r, jInteger width, jInteger precision);
	jReal DS Rad2Deg(jReal* radians);
	HRECT DS Rect(jReal* minx, jReal* miny, jReal* maxx, jReal* maxy);
	HRECT DS RectFromLoc(HLOCATION min, HLOCATION max);
	jNothing DS RecycleGuardPosition(HUNIT hUnit);
	jNothing DS RegionAddCell(HREGION whichRegion, jReal* x, jReal* y);
	jNothing DS RegionAddCellAtLoc(HREGION whichRegion, HLOCATION whichLocation);
	jNothing DS RegionAddRect(HREGION whichRegion, HRECT r);
	jNothing DS RegionClearCell(HREGION whichRegion, jReal* x, jReal* y);
	jNothing DS RegionClearCellAtLoc(HREGION whichRegion, HLOCATION whichLocation);
	jNothing DS RegionClearRect(HREGION whichRegion, HRECT r);
	jNothing DS RegisterStackedSound(HSOUND soundHandle, jBoolean byPosition, jReal* rectwidth, jReal* rectheight);
	jNothing DS ReloadGame();
	jBoolean DS ReloadGameCachesFromDisk();
	jNothing DS RemoveAllGuardPositions(HPLAYER num);
	jNothing DS RemoveDestructable(HDESTRUCTABLE d);
	jNothing DS RemoveGuardPosition(HUNIT hUnit);
	jNothing DS RemoveInjuries();
	jNothing DS RemoveItem(HITEM whichItem);
	jNothing DS RemoveItemFromAllStock(jInteger itemId);
	jNothing DS RemoveItemFromStock(HUNIT whichUnit, jInteger itemId);
	jNothing DS RemoveLocation(HLOCATION whichLocation);
	jNothing DS RemovePlayer(HPLAYER whichPlayer, HPLAYERGAMERESULT gameResult);
	jNothing DS RemoveRect(HRECT whichRect);
	jNothing DS RemoveRegion(HREGION whichRegion);
	jBoolean DS RemoveSaveDirectory(jString sourceDirName);
	jNothing DS RemoveSavedBoolean(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS RemoveSavedHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS RemoveSavedInteger(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS RemoveSavedReal(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS RemoveSavedString(HHASHTABLE table, jInteger parentKey, jInteger childKey);
	jNothing DS RemoveSiege();
	jNothing DS RemoveUnit(HUNIT whichUnit);
	jNothing DS RemoveUnitFromAllStock(jInteger unitId);
	jNothing DS RemoveUnitFromStock(HUNIT whichUnit, jInteger unitId);
	jNothing DS RemoveWeatherEffect(HWEATHEREFFECT whichEffect);
	jBoolean DS RenameSaveDirectory(jString sourceDirName, jString destDirName);
	jNothing DS ResetCaptainLocs();
	jNothing DS ResetTerrainFog();
	jNothing DS ResetToGameCamera(jReal* duration);
	jNothing DS ResetTrigger(jTrigger whichTrigger);
	jNothing DS ResetUbersplat(HUBERSPLAT whichSplat);
	jNothing DS ResetUnitLookAt(HUNIT whichUnit);
	jNothing DS RestartGame(jBoolean doScoreScreen);
	HUNIT DS RestoreUnit(HGAMECACHE cache, jString missionKey, jString key, HPLAYER forWhichPlayer, jReal* x, jReal* y, jReal* facing);
	jNothing DS ResumeMusic();
	jNothing DS ResumeTimer(HTIMER whichTimer);
	jNothing DS ReturnGuardPosts();
	jBoolean DS ReviveHero(HUNIT whichHero, jReal* x, jReal* y, jBoolean doEyecandy);
	jBoolean DS ReviveHeroLoc(HUNIT whichHero, HLOCATION loc, jBoolean doEyecandy);
	jInteger DS S2I(jString s);
	jReal DS S2R(jString s);
	jBoolean DS SaveAbilityHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HABILITY whichAbility);
	jBoolean DS SaveAgentHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HAGENT whichAgent);
	jNothing DS SaveBoolean(HHASHTABLE table, jInteger parentKey, jInteger childKey, jBoolean value);
	jBoolean DS SaveBooleanExprHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HBOOLEXPR whichBoolexpr);
	jBoolean DS SaveButtonHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HBUTTON whichButton);
	jBoolean DS SaveDefeatConditionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HDEFEATCONDITION whichDefeatcondition);
	jBoolean DS SaveDestructableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HDESTRUCTABLE whichDestructable);
	jBoolean DS SaveDialogHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HDIALOG whichDialog);
	jBoolean DS SaveEffectHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HEFFECT whichEffect);
	jBoolean DS SaveFogModifierHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HFOGMODIFIER whichFogModifier);
	jBoolean DS SaveFogStateHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HFOGSTATE whichFogState);
	jBoolean DS SaveForceHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HFORCE whichForce);
	jNothing DS SaveGame(jString saveFileName);
	jBoolean DS SaveGameCache(HGAMECACHE whichCache);
	jBoolean DS SaveGameExists(jString saveName);
	jBoolean DS SaveGroupHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HGROUP whichGroup);
	jBoolean DS SaveHashtableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HHASHTABLE whichHashtable);
	jBoolean DS SaveImageHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HIMAGE whichImage);
	jNothing DS SaveInteger(HHASHTABLE table, jInteger parentKey, jInteger childKey, jInteger value);
	jBoolean DS SaveItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HITEM whichItem);
	jBoolean DS SaveItemPoolHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HITEMPOOL whichItempool);
	jBoolean DS SaveLeaderboardHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HLEADERBOARD whichLeaderboard);
	jBoolean DS SaveLightningHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HLIGHTNING whichLightning);
	jBoolean DS SaveLocationHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HLOCATION whichLocation);
	jBoolean DS SaveMultiboardHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HMULTIBOARD whichMultiboard);
	jBoolean DS SaveMultiboardItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HMULTIBOARDITEM whichMultiboarditem);
	jBoolean DS SavePlayerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HPLAYER whichPlayer);
	jBoolean DS SaveQuestHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HQUEST whichQuest);
	jBoolean DS SaveQuestItemHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HQUESTITEM whichQuestitem);
	jNothing DS SaveReal(HHASHTABLE table, jInteger parentKey, jInteger childKey, jReal* value);
	jBoolean DS SaveRectHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HRECT whichRect);
	jBoolean DS SaveRegionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HREGION whichRegion);
	jBoolean DS SaveSoundHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HSOUND whichSound);
	jBoolean DS SaveStr(HHASHTABLE table, jInteger parentKey, jInteger childKey, jString value);
	jBoolean DS SaveTextTagHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTEXTTAG whichTexttag);
	jBoolean DS SaveTimerDialogHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTIMERDIALOG whichTimerdialog);
	jBoolean DS SaveTimerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTIMER whichTimer);
	jBoolean DS SaveTrackableHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTRACKABLE whichTrackable);
	jBoolean DS SaveTriggerActionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTRIGGERACTION whichTriggeraction);
	jBoolean DS SaveTriggerConditionHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HTRIGGERCONDITION whichTriggercondition);
	jBoolean DS SaveTriggerEventHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HEVENT whichEvent);
	jBoolean DS SaveTriggerHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, jTrigger whichTrigger);
	jBoolean DS SaveUbersplatHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HUBERSPLAT whichUbersplat);
	jBoolean DS SaveUnitHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HUNIT whichUnit);
	jBoolean DS SaveUnitPoolHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HUNITPOOL whichUnitpool);
	jBoolean DS SaveWidgetHandle(HHASHTABLE table, jInteger parentKey, jInteger childKey, HWIDGET whichWidget);
	jNothing DS SelectHeroSkill(HUNIT whichHero, jInteger abilcode);
	jNothing DS SelectUnit(HUNIT whichUnit, jBoolean flag);
	jNothing DS SetAllItemTypeSlots(jInteger slots);
	jNothing DS SetAllUnitTypeSlots(jInteger slots);
	jNothing DS SetAllianceTarget(HUNIT arg1);
	jNothing DS SetAllyColorFilterState(jInteger state);
	jNothing DS SetAltMinimapIcon(jString iconPath);
	jNothing DS SetAmphibious();
	jNothing DS SetBlight(HPLAYER whichPlayer, jReal* x, jReal* y, jReal* radius, jBoolean addBlight);
	jNothing DS SetBlightLoc(HPLAYER whichPlayer, HLOCATION whichLocation, jReal* radius, jBoolean addBlight);
	jNothing DS SetBlightPoint(HPLAYER whichPlayer, jReal* x, jReal* y, jBoolean addBlight);
	jNothing DS SetBlightRect(HPLAYER whichPlayer, HRECT r, jBoolean addBlight);
	jNothing DS SetCameraBounds(jReal* x1, jReal* y1, jReal* x2, jReal* y2, jReal* x3, jReal* y3, jReal* x4, jReal* y4);
	jNothing DS SetCameraField(HCAMERAFIELD whichField, jReal* value, jReal* duration);
	jNothing DS SetCameraOrientController(HUNIT whichUnit, jReal* xoffset, jReal* yoffset);
	jNothing DS SetCameraPosition(jReal* x, jReal* y);
	jNothing DS SetCameraQuickPosition(jReal* x, jReal* y);
	jNothing DS SetCameraRotateMode(jReal* x, jReal* y, jReal* radiansToSweep, jReal* duration);
	jNothing DS SetCameraTargetController(HUNIT whichUnit, jReal* xoffset, jReal* yoffset, jBoolean inheritOrientation);
	jNothing DS SetCampaignAI();
	jNothing DS SetCampaignAvailable(jInteger campaignNumber, jBoolean available);
	jNothing DS SetCampaignMenuRace(HRACE r);
	jNothing DS SetCampaignMenuRaceEx(jInteger campaignIndex);
	jNothing DS SetCaptainChanges(jBoolean arg1);
	jNothing DS SetCaptainHome(jInteger arg1, jReal* arg2, jReal* arg3);
	jNothing DS SetCineFilterBlendMode(HBLENDMODE whichMode);
	jNothing DS SetCineFilterDuration(jReal* duration);
	jNothing DS SetCineFilterEndColor(jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetCineFilterEndUV(jReal* minu, jReal* minv, jReal* maxu, jReal* maxv);
	jNothing DS SetCineFilterStartColor(jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetCineFilterStartUV(jReal* minu, jReal* minv, jReal* maxu, jReal* maxv);
	jNothing DS SetCineFilterTexMapFlags(HTEXMAPFLAGS whichFlags);
	jNothing DS SetCineFilterTexture(jString filename);
	jNothing DS SetCinematicCamera(jString cameraModelFile);
	jNothing DS SetCinematicScene(jInteger portraitUnitId, HPLAYERCOLOR color, jString speakerTitle, jString text, jReal* sceneDuration, jReal* voiceoverDuration);
	jNothing DS SetCreatureDensity(HMAPDENSITY whichdensity);
	jNothing DS SetCreepCampFilterState(jBoolean state);
	jNothing DS SetCustomCampaignButtonVisible(jInteger whichButton, jBoolean visible);
	jNothing DS SetDayNightModels(jString terrainDNCFile, jString unitDNCFile);
	jNothing DS SetDefaultDifficulty(HGAMEDIFFICULTY g);
	jNothing DS SetDefendPlayer(jBoolean arg1);
	jNothing DS SetDestructableAnimation(HDESTRUCTABLE d, jString whichAnimation);
	jNothing DS SetDestructableAnimationSpeed(HDESTRUCTABLE d, jReal* speedFactor);
	jNothing DS SetDestructableInvulnerable(HDESTRUCTABLE d, jBoolean flag);
	jNothing DS SetDestructableLife(HDESTRUCTABLE d, jReal* life);
	jNothing DS SetDestructableMaxLife(HDESTRUCTABLE d, jReal* max);
	jNothing DS SetDestructableOccluderHeight(HDESTRUCTABLE d, jReal* height);
	jNothing DS SetDoodadAnimation(jReal* x, jReal* y, jReal* radius, jInteger doodadID, jBoolean nearestOnly, jString animName, jBoolean animRandom);
	jNothing DS SetDoodadAnimationRect(HRECT r, jInteger doodadID, jString animName, jBoolean animRandom);
	jNothing DS SetEdCinematicAvailable(jInteger campaignNumber, jBoolean available);
	jBoolean DS SetExpansion(HUNIT arg1, jInteger arg2);
	jNothing DS SetFloatGameState(HFGAMESTATE whichFloatGameState, jReal* value);
	jNothing DS SetFogStateRadius(HPLAYER forWhichPlayer, HFOGSTATE whichState, jReal* centerx, jReal* centerY, jReal* radius, jBoolean useSharedVision);
	jNothing DS SetFogStateRadiusLoc(HPLAYER forWhichPlayer, HFOGSTATE whichState, HLOCATION center, jReal* radius, jBoolean useSharedVision);
	jNothing DS SetFogStateRect(HPLAYER forWhichPlayer, HFOGSTATE whichState, HRECT where, jBoolean useSharedVision);
	jNothing DS SetGameDifficulty(HGAMEDIFFICULTY whichdifficulty);
	jNothing DS SetGamePlacement(HPLACEMENT whichPlacementType);
	jNothing DS SetGameSpeed(HGAMESPEED whichspeed);
	jNothing DS SetGameTypeSupported(HGAMETYPE whichGameType, jBoolean value);
	jNothing DS SetGroupsFlee(jBoolean arg1);
	jNothing DS SetHeroAgi(HUNIT whichHero, jInteger newAgi, jBoolean permanent);
	jNothing DS SetHeroInt(HUNIT whichHero, jInteger newInt, jBoolean permanent);
	jNothing DS SetHeroLevel(HUNIT whichHero, jInteger level, jBoolean showEyeCandy);
	jNothing DS SetHeroLevels(jCode arg1);
	jNothing DS SetHeroStr(HUNIT whichHero, jInteger newStr, jBoolean permanent);
	jNothing DS SetHeroXP(HUNIT whichHero, jInteger newXpVal, jBoolean showEyeCandy);
	jNothing DS SetHeroesBuyItems(jBoolean arg1);
	jNothing DS SetHeroesFlee(jBoolean arg1);
	jNothing DS SetHeroesTakeItems(jBoolean arg1);
	jNothing DS SetIgnoreInjured(jBoolean arg1);
	jNothing DS SetImageAboveWater(HIMAGE whichImage, jBoolean flag, jBoolean useWaterAlpha);
	jNothing DS SetImageColor(HIMAGE whichImage, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetImageConstantHeight(HIMAGE whichImage, jBoolean flag, jReal* height);
	jNothing DS SetImagePosition(HIMAGE whichImage, jReal* x, jReal* y, jReal* z);
	jNothing DS SetImageRender(HIMAGE whichImage, jBoolean flag);
	jNothing DS SetImageRenderAlways(HIMAGE whichImage, jBoolean flag);
	jNothing DS SetImageType(HIMAGE whichImage, jInteger imageType);
	jNothing DS SetIntegerGameState(HIGAMESTATE whichIntegerGameState, jInteger value);
	jNothing DS SetIntroShotModel(jString introModelPath);
	jNothing DS SetIntroShotText(jString introText);
	jNothing DS SetItemCharges(HITEM whichItem, jInteger charges);
	jNothing DS SetItemDropID(HITEM whichItem, jInteger unitId);
	jNothing DS SetItemDropOnDeath(HITEM whichItem, jBoolean flag);
	jNothing DS SetItemDroppable(HITEM i, jBoolean flag);
	jNothing DS SetItemInvulnerable(HITEM whichItem, jBoolean flag);
	jNothing DS SetItemPawnable(HITEM i, jBoolean flag);
	jNothing DS SetItemPlayer(HITEM whichItem, HPLAYER whichPlayer, jBoolean changeColor);
	jNothing DS SetItemPosition(HITEM i, jReal* x, jReal* y);
	jNothing DS SetItemTypeSlots(HUNIT whichUnit, jInteger slots);
	jNothing DS SetItemUserData(HITEM whichItem, jInteger data);
	jNothing DS SetItemVisible(HITEM whichItem, jBoolean show);
	jBoolean DS SetLightningColor(HLIGHTNING whichBolt, jReal* r, jReal* g, jReal* b, jReal* a);
	jNothing DS SetMapDescription(jString description);
	jNothing DS SetMapFlag(HMAPFLAG whichMapFlag, jBoolean value);
	jNothing DS SetMapMusic(jString musicName, jBoolean random, jInteger index);
	jNothing DS SetMapName(jString name);
	jNothing DS SetMeleeAI();
	jNothing DS SetMissionAvailable(jInteger campaignNumber, jInteger missionNumber, jBoolean available);
	jNothing DS SetMusicPlayPosition(jInteger millisecs);
	jNothing DS SetMusicVolume(jInteger volume);
	jNothing DS SetNewHeroes(jBoolean arg1);
	jNothing DS SetOpCinematicAvailable(jInteger campaignNumber, jBoolean available);
	jNothing DS SetPeonsRepair(jBoolean arg1);
	jNothing DS SetPlayerAbilityAvailable(HPLAYER whichPlayer, jInteger abilid, jBoolean avail);
	jNothing DS SetPlayerAlliance(HPLAYER sourcePlayer, HPLAYER otherPlayer, HALLIANCETYPE whichAllianceSetting, jBoolean value);
	jNothing DS SetPlayerColor(HPLAYER whichPlayer, HPLAYERCOLOR color);
	jNothing DS SetPlayerController(HPLAYER whichPlayer, HMAPCONTROL controlType);
	jNothing DS SetPlayerHandicap(HPLAYER whichPlayer, jReal* handicap);
	jNothing DS SetPlayerHandicapXP(HPLAYER whichPlayer, jReal* handicap);
	jNothing DS SetPlayerName(HPLAYER whichPlayer, jString name);
	jNothing DS SetPlayerOnScoreScreen(HPLAYER whichPlayer, jBoolean flag);
	jNothing DS SetPlayerRacePreference(HPLAYER whichPlayer, HRACEPREFERENCE whichRacePreference);
	jNothing DS SetPlayerRaceSelectable(HPLAYER whichPlayer, jBoolean value);
	jNothing DS SetPlayerStartLocation(HPLAYER whichPlayer, jInteger startLocIndex);
	jNothing DS SetPlayerState(HPLAYER whichPlayer, HPLAYERSTATE whichPlayerState, jInteger value);
	jNothing DS SetPlayerTaxRate(HPLAYER sourcePlayer, HPLAYER otherPlayer, HPLAYERSTATE whichResource, jInteger rate);
	jNothing DS SetPlayerTeam(HPLAYER whichPlayer, jInteger whichTeam);
	jNothing DS SetPlayerTechMaxAllowed(HPLAYER whichPlayer, jInteger techid, jInteger maximum);
	jNothing DS SetPlayerTechResearched(HPLAYER whichPlayer, jInteger techid, jInteger setToLevel);
	jNothing DS SetPlayerUnitsOwner(HPLAYER whichPlayer, jInteger newOwner);
	jNothing DS SetPlayers(jInteger playercount);
	jBoolean DS SetProduce(jInteger arg1, jInteger arg2, jInteger arg3);
	jNothing DS SetRandomPaths(jBoolean arg1);
	jNothing DS SetRandomSeed(jInteger seed);
	jNothing DS SetRect(HRECT whichRect, jReal* minx, jReal* miny, jReal* maxx, jReal* maxy);
	jNothing DS SetRectFromLoc(HRECT whichRect, HLOCATION min, HLOCATION max);
	jNothing DS SetReplacementCount(jInteger arg1);
	jNothing DS SetReservedLocalHeroButtons(jInteger reserved);
	jNothing DS SetResourceAmount(HUNIT whichUnit, jInteger amount);
	jNothing DS SetResourceDensity(HMAPDENSITY whichdensity);
	jNothing DS SetSkyModel(jString skyModelFile);
	jNothing DS SetSlowChopping(jBoolean arg1);
	jNothing DS SetSmartArtillery(jBoolean arg1);
	jNothing DS SetSoundChannel(HSOUND soundHandle, jInteger channel);
	jNothing DS SetSoundConeAngles(HSOUND soundHandle, jReal* inside, jReal* outside, jInteger outsideVolume);
	jNothing DS SetSoundConeOrientation(HSOUND soundHandle, jReal* x, jReal* y, jReal* z);
	jNothing DS SetSoundDistanceCutoff(HSOUND soundHandle, jReal* cutoff);
	jNothing DS SetSoundDistances(HSOUND soundHandle, jReal* minDist, jReal* maxDist);
	jNothing DS SetSoundDuration(HSOUND soundHandle, jInteger duration);
	jNothing DS SetSoundParamsFromLabel(HSOUND soundHandle, jString soundLabel);
	jNothing DS SetSoundPitch(HSOUND soundHandle, jReal* pitch);
	jNothing DS SetSoundPlayPosition(HSOUND soundHandle, jInteger millisecs);
	jNothing DS SetSoundPosition(HSOUND soundHandle, jReal* x, jReal* y, jReal* z);
	jNothing DS SetSoundVelocity(HSOUND soundHandle, jReal* x, jReal* y, jReal* z);
	jNothing DS SetSoundVolume(HSOUND soundHandle, jInteger volume);
	jNothing DS SetStackedSound(jString arg1, jReal* arg2, jReal* arg3);
	jNothing DS SetStackedSoundRect(jString arg1, HRECT arg2);
	jNothing DS SetStagePoint(jReal* arg1, jReal* arg2);
	jNothing DS SetStartLocPrio(jInteger whichStartLoc, jInteger prioSlotIndex, jInteger otherStartLocIndex, HSTARTLOCPRIO priority);
	jNothing DS SetStartLocPrioCount(jInteger whichStartLoc, jInteger prioSlotCount);
	jNothing DS SetTargetHeroes(jBoolean arg1);
	jNothing DS SetTeams(jInteger teamcount);
	jNothing DS SetTerrainFog(jReal* a, jReal* b, jReal* c, jReal* d, jReal* e);
	jNothing DS SetTerrainFogEx(jInteger style, jReal* zstart, jReal* zend, jReal* density, jReal* red, jReal* green, jReal* blue);
	jNothing DS SetTerrainPathable(jReal* x, jReal* y, HPATHINGTYPE t, jBoolean flag);
	jNothing DS SetTerrainType(jReal* x, jReal* y, jInteger terrainType, jInteger variation, jInteger area, jInteger shape);
	jNothing DS SetTextTagAge(HTEXTTAG t, jReal* age);
	jNothing DS SetTextTagColor(HTEXTTAG t, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetTextTagFadepoint(HTEXTTAG t, jReal* fadepoint);
	jNothing DS SetTextTagLifespan(HTEXTTAG t, jReal* lifespan);
	jNothing DS SetTextTagPermanent(HTEXTTAG t, jBoolean flag);
	jNothing DS SetTextTagPos(HTEXTTAG t, jReal* x, jReal* y, jReal* heightOffset);
	jNothing DS SetTextTagPosUnit(HTEXTTAG t, HUNIT whichUnit, jReal* heightOffset);
	jNothing DS SetTextTagSuspended(HTEXTTAG t, jBoolean flag);
	jNothing DS SetTextTagText(HTEXTTAG t, jString s, jReal* height);
	jNothing DS SetTextTagVelocity(HTEXTTAG t, jReal* xvel, jReal* yvel);
	jNothing DS SetTextTagVisibility(HTEXTTAG t, jBoolean flag);
	jNothing DS SetThematicMusicPlayPosition(jInteger millisecs);
	jNothing DS SetTimeOfDayScale(jReal* r);
	jNothing DS SetTutorialCleared(jBoolean cleared);
	jNothing DS SetUbersplatRender(HUBERSPLAT whichSplat, jBoolean flag);
	jNothing DS SetUbersplatRenderAlways(HUBERSPLAT whichSplat, jBoolean flag);
	jInteger DS SetUnitAbilityLevel(HUNIT whichUnit, jInteger abilcode, jInteger level);
	jNothing DS SetUnitAcquireRange(HUNIT whichUnit, jReal* newAcquireRange);
	jNothing DS SetUnitAnimation(HUNIT whichUnit, jString whichAnimation);
	jNothing DS SetUnitAnimationByIndex(HUNIT whichUnit, jInteger whichAnimation);
	jNothing DS SetUnitAnimationWithRarity(HUNIT whichUnit, jString whichAnimation, HRARITYCONTROL rarity);
	jNothing DS SetUnitBlendTime(HUNIT whichUnit, jReal* blendTime);
	jNothing DS SetUnitColor(HUNIT whichUnit, HPLAYERCOLOR whichColor);
	jNothing DS SetUnitCreepGuard(HUNIT whichUnit, jBoolean creepGuard);
	jNothing DS SetUnitExploded(HUNIT whichUnit, jBoolean exploded);
	jNothing DS SetUnitFacing(HUNIT whichUnit, jReal* facingAngle);
	jNothing DS SetUnitFacingTimed(HUNIT whichUnit, jReal* facingAngle, jReal* duration);
	jNothing DS SetUnitFlyHeight(HUNIT whichUnit, jReal* newHeight, jReal* rate);
	jNothing DS SetUnitFog(jReal* a, jReal* b, jReal* c, jReal* d, jReal* e);
	jNothing DS SetUnitInvulnerable(HUNIT whichUnit, jBoolean flag);
	jNothing DS SetUnitLookAt(HUNIT whichUnit, jString whichBone, HUNIT lookAtTarget, jReal* offsetX, jReal* offsetY, jReal* offsetZ);
	jNothing DS SetUnitMoveSpeed(HUNIT whichUnit, jReal* newSpeed);
	jNothing DS SetUnitOwner(HUNIT whichUnit, HPLAYER whichPlayer, jBoolean changeColor);
	jNothing DS SetUnitPathing(HUNIT whichUnit, jBoolean flag);
	jNothing DS SetUnitPosition(HUNIT whichUnit, jReal* newX, jReal* newY);
	jNothing DS SetUnitPositionLoc(HUNIT whichUnit, HLOCATION whichLocation);
	jNothing DS SetUnitPropWindow(HUNIT whichUnit, jReal* newPropWindowAngle);
	jNothing DS SetUnitRescuable(HUNIT whichUnit, HPLAYER byWhichPlayer, jBoolean flag);
	jNothing DS SetUnitRescueRange(HUNIT whichUnit, jReal* range);
	jNothing DS SetUnitScale(HUNIT whichUnit, jReal* scaleX, jReal* scaleY, jReal* scaleZ);
	jNothing DS SetUnitState(HUNIT whichUnit, HUNITSTATE whichUnitState, jReal* newVal);
	jNothing DS SetUnitTimeScale(HUNIT whichUnit, jReal* timeScale);
	jNothing DS SetUnitTurnSpeed(HUNIT whichUnit, jReal* newTurnSpeed);
	jNothing DS SetUnitTypeSlots(HUNIT whichUnit, jInteger slots);
	jNothing DS SetUnitUseFood(HUNIT whichUnit, jBoolean useFood);
	jNothing DS SetUnitUserData(HUNIT whichUnit, jInteger data);
	jNothing DS SetUnitVertexColor(HUNIT whichUnit, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetUnitX(HUNIT whichUnit, jReal* newX);
	jNothing DS SetUnitY(HUNIT whichUnit, jReal* newY);
	jNothing DS SetUnitsFlee(jBoolean arg1);
	jBoolean DS SetUpgrade(jInteger arg1);
	jNothing DS SetWatchMegaTargets(jBoolean arg1);
	jNothing DS SetWaterBaseColor(jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS SetWaterDeforms(jBoolean val);
	jNothing DS SetWidgetLife(HWIDGET whichWidget, jReal* newLife);
	jNothing DS ShiftTownSpot(jReal* arg1, jReal* arg2);
	jNothing DS ShowDestructable(HDESTRUCTABLE d, jBoolean flag);
	jNothing DS ShowImage(HIMAGE whichImage, jBoolean flag);
	jNothing DS ShowInterface(jBoolean flag, jReal* fadeDuration);
	jNothing DS ShowUbersplat(HUBERSPLAT whichSplat, jBoolean flag);
	jNothing DS ShowUnit(HUNIT whichUnit, jBoolean show);
	jReal DS Sin(jReal* radians);
	jNothing DS Sleep(jReal* arg1);
	jReal DS SquareRoot(jReal* x);
	jNothing DS StartCampaignAI(HPLAYER num, jString script);
	jNothing DS StartGetEnemyBase();
	jNothing DS StartMeleeAI(HPLAYER num, jString script);
	jNothing DS StartSound(HSOUND soundHandle);
	jNothing DS StartThread(jCode arg1);
	jNothing DS StopCamera();
	jNothing DS StopGathering();
	jNothing DS StopMusic(jBoolean fadeOut);
	jNothing DS StopSound(HSOUND soundHandle, jBoolean killWhenDone, jBoolean fadeOut);
	jNothing DS StoreBoolean(HGAMECACHE cache, jString missionKey, jString key, jBoolean value);
	jNothing DS StoreInteger(HGAMECACHE cache, jString missionKey, jString key, jInteger value);
	jNothing DS StoreReal(HGAMECACHE cache, jString missionKey, jString key, jReal* value);
	jBoolean DS StoreString(HGAMECACHE cache, jString missionKey, jString key, jString value);
	jBoolean DS StoreUnit(HGAMECACHE cache, jString missionKey, jString key, HUNIT whichUnit);
	jString DS StringCase(jString source, jBoolean upper);
	jInteger DS StringHash(jString s);
	jInteger DS StringLength(jString s);
	jString DS SubString(jString source, jInteger start, jInteger end);
	jBoolean DS SuicidePlayer(HPLAYER arg1, jBoolean arg2);
	jBoolean DS SuicidePlayerUnits(HPLAYER arg1, jBoolean arg2);
	jNothing DS SuicideUnit(jInteger arg1, jInteger arg2);
	jNothing DS SuicideUnitEx(jInteger arg1, jInteger arg2, jInteger arg3);
	jNothing DS SuspendHeroXP(HUNIT whichHero, jBoolean flag);
	jNothing DS SuspendTimeOfDay(jBoolean b);
	jNothing DS SyncSelections();
	jNothing DS SyncStoredBoolean(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS SyncStoredInteger(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS SyncStoredReal(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS SyncStoredString(HGAMECACHE cache, jString missionKey, jString key);
	jNothing DS SyncStoredUnit(HGAMECACHE cache, jString missionKey, jString key);
	jReal DS Tan(jReal* radians);
	jNothing DS TeleportCaptain(jReal* arg1, jReal* arg2);
	HTERRAINDEFORMATION DS TerrainDeformCrater(jReal* x, jReal* y, jReal* radius, jReal* depth, jInteger duration, jBoolean permanent);
	HTERRAINDEFORMATION DS TerrainDeformRandom(jReal* x, jReal* y, jReal* radius, jReal* minDelta, jReal* maxDelta, jInteger duration, jInteger updateInterval);
	HTERRAINDEFORMATION DS TerrainDeformRipple(jReal* x, jReal* y, jReal* radius, jReal* depth, jInteger duration, jInteger count, jReal* spaceWaves, jReal* timeWaves, jReal* radiusStartPct, jBoolean limitNeg);
	jNothing DS TerrainDeformStop(HTERRAINDEFORMATION deformation, jInteger duration);
	jNothing DS TerrainDeformStopAll();
	HTERRAINDEFORMATION DS TerrainDeformWave(jReal* x, jReal* y, jReal* dirX, jReal* dirY, jReal* distance, jReal* speed, jReal* radius, jReal* depth, jInteger trailTime, jInteger count);
	jNothing DS TimerDialogDisplay(HTIMERDIALOG whichDialog, jBoolean display);
	jNothing DS TimerDialogSetRealTimeRemaining(HTIMERDIALOG whichDialog, jReal* timeRemaining);
	jNothing DS TimerDialogSetSpeed(HTIMERDIALOG whichDialog, jReal* speedMultFactor);
	jNothing DS TimerDialogSetTimeColor(HTIMERDIALOG whichDialog, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jNothing DS TimerDialogSetTitle(HTIMERDIALOG whichDialog, jString title);
	jNothing DS TimerDialogSetTitleColor(HTIMERDIALOG whichDialog, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jReal DS TimerGetElapsed(HTIMER whichTimer);
	jReal DS TimerGetRemaining(HTIMER whichTimer);
	jReal DS TimerGetTimeout(HTIMER whichTimer);
	jNothing DS TimerStart(HTIMER whichTimer, jReal* timeout, jBoolean periodic, jCode handlerFunc);
	jBoolean DS TownHasHall(jInteger arg1);
	jBoolean DS TownHasMine(jInteger arg1);
	jBoolean DS TownThreatened();
	jInteger DS TownWithMine();
	HTRIGGERACTION DS TriggerAddAction(jTrigger whichTrigger, jCode actionFunc);
	HTRIGGERCONDITION DS TriggerAddCondition(jTrigger whichTrigger, HBOOLEXPR condition);
	jNothing DS TriggerClearActions(jTrigger whichTrigger);
	jNothing DS TriggerClearConditions(jTrigger whichTrigger);
	jBoolean DS TriggerEvaluate(jTrigger whichTrigger);
	jNothing DS TriggerExecute(jTrigger whichTrigger);
	jNothing DS TriggerExecuteWait(jTrigger whichTrigger);
	HEVENT DS TriggerRegisterDeathEvent(jTrigger whichTrigger, HWIDGET whichWidget);
	HEVENT DS TriggerRegisterDialogButtonEvent(jTrigger whichTrigger, HBUTTON whichButton);
	HEVENT DS TriggerRegisterDialogEvent(jTrigger whichTrigger, HDIALOG whichDialog);
	HEVENT DS TriggerRegisterEnterRegion(jTrigger whichTrigger, HREGION whichRegion, HBOOLEXPR filter);
	HEVENT DS TriggerRegisterFilterUnitEvent(jTrigger whichTrigger, HUNIT whichUnit, HUNITEVENT whichEvent, HBOOLEXPR filter);
	HEVENT DS TriggerRegisterGameEvent(jTrigger whichTrigger, HGAMEEVENT whichGameEvent);
	HEVENT DS TriggerRegisterGameStateEvent(jTrigger whichTrigger, HGAMESTATE whichState, HLIMITOP opcode, jReal* limitval);
	HEVENT DS TriggerRegisterLeaveRegion(jTrigger whichTrigger, HREGION whichRegion, HBOOLEXPR filter);
	HEVENT DS TriggerRegisterPlayerAllianceChange(jTrigger whichTrigger, HPLAYER whichPlayer, HALLIANCETYPE whichAlliance);
	HEVENT DS TriggerRegisterPlayerChatEvent(jTrigger whichTrigger, HPLAYER whichPlayer, jString chatMessageToDetect, jBoolean exactMatchOnly);
	HEVENT DS TriggerRegisterPlayerEvent(jTrigger whichTrigger, HPLAYER whichPlayer, HPLAYEREVENT whichPlayerEvent);
	HEVENT DS TriggerRegisterPlayerStateEvent(jTrigger whichTrigger, HPLAYER whichPlayer, HPLAYERSTATE whichState, HLIMITOP opcode, jReal* limitval);
	HEVENT DS TriggerRegisterPlayerUnitEvent(jTrigger whichTrigger, HPLAYER whichPlayer, HPLAYERUNITEVENT whichPlayerUnitEvent, HBOOLEXPR filter);
	HEVENT DS TriggerRegisterTimerEvent(jTrigger whichTrigger, jReal* timeout, jBoolean periodic);
	HEVENT DS TriggerRegisterTimerExpireEvent(jTrigger whichTrigger, HTIMER t);
	HEVENT DS TriggerRegisterTrackableHitEvent(jTrigger whichTrigger, HTRACKABLE t);
	HEVENT DS TriggerRegisterTrackableTrackEvent(jTrigger whichTrigger, HTRACKABLE t);
	HEVENT DS TriggerRegisterUnitEvent(jTrigger whichTrigger, HUNIT whichUnit, HUNITEVENT whichEvent);
	HEVENT DS TriggerRegisterUnitInRange(jTrigger whichTrigger, HUNIT whichUnit, jReal* range, HBOOLEXPR filter);
	HEVENT DS TriggerRegisterUnitStateEvent(jTrigger whichTrigger, HUNIT whichUnit, HUNITSTATE whichState, HLIMITOP opcode, jReal* limitval);
	HEVENT DS TriggerRegisterVariableEvent(jTrigger whichTrigger, jString varName, HLIMITOP opcode, jReal* limitval);
	jNothing DS TriggerRemoveAction(jTrigger whichTrigger, HTRIGGERACTION whichAction);
	jNothing DS TriggerRemoveCondition(jTrigger whichTrigger, HTRIGGERCONDITION whichCondition);
	jNothing DS TriggerSleepAction(jReal* timeout);
	jNothing DS TriggerSyncReady();
	jNothing DS TriggerSyncStart();
	jNothing DS TriggerWaitForSound(HSOUND s, jReal* offset);
	jNothing DS TriggerWaitOnSleeps(jTrigger whichTrigger, jBoolean flag);
	jBoolean DS UnitAddAbility(HUNIT whichUnit, jInteger abilityId);
	jNothing DS UnitAddIndicator(HUNIT whichUnit, jInteger red, jInteger green, jInteger blue, jInteger alpha);
	jBoolean DS UnitAddItem(HUNIT whichUnit, HITEM whichItem);
	HITEM DS UnitAddItemById(HUNIT whichUnit, jInteger itemId);
	jBoolean DS UnitAddItemToSlotById(HUNIT whichUnit, jInteger itemId, jInteger itemSlot);
	jNothing DS UnitAddSleep(HUNIT whichUnit, jBoolean add);
	jNothing DS UnitAddSleepPerm(HUNIT whichUnit, jBoolean add);
	jBoolean DS UnitAddType(HUNIT whichUnit, HUNITTYPE whichUnitType);
	jBoolean DS UnitAlive(HUNIT arg1);
	jNothing DS UnitApplyTimedLife(HUNIT whichUnit, jInteger buffId, jReal* duration);
	jBoolean DS UnitCanSleep(HUNIT whichUnit);
	jBoolean DS UnitCanSleepPerm(HUNIT whichUnit);
	jInteger DS UnitCountBuffsEx(HUNIT whichUnit, jBoolean removePositive, jBoolean removeNegative, jBoolean magic, jBoolean physical, jBoolean timedLife, jBoolean aura, jBoolean autoDispel);
	jBoolean DS UnitDamagePoint(HUNIT whichUnit, jReal* delay, jReal* radius, jReal* x, jReal* y, jReal* amount, jBoolean attack, jBoolean ranged, HATTACKTYPE attackType, HDAMAGETYPE damageType, HWEAPONTYPE weaponType);
	jBoolean DS UnitDamageTarget(HUNIT whichUnit, HWIDGET target, jReal* amount, jBoolean attack, jBoolean ranged, HATTACKTYPE attackType, HDAMAGETYPE damageType, HWEAPONTYPE weaponType);
	jBoolean DS UnitDropItemPoint(HUNIT whichUnit, HITEM whichItem, jReal* x, jReal* y);
	jBoolean DS UnitDropItemSlot(HUNIT whichUnit, HITEM whichItem, jInteger slot);
	jBoolean DS UnitDropItemTarget(HUNIT whichUnit, HITEM whichItem, HWIDGET target);
	jBoolean DS UnitHasBuffsEx(HUNIT whichUnit, jBoolean removePositive, jBoolean removeNegative, jBoolean magic, jBoolean physical, jBoolean timedLife, jBoolean aura, jBoolean autoDispel);
	jBoolean DS UnitHasItem(HUNIT whichUnit, HITEM whichItem);
	jInteger DS UnitId(jString unitIdString);
	jString DS UnitId2String(jInteger unitId);
	jBoolean DS UnitIgnoreAlarm(HUNIT whichUnit, jBoolean flag);
	jBoolean DS UnitIgnoreAlarmToggled(HUNIT whichUnit);
	jInteger DS UnitInventorySize(HUNIT whichUnit);
	jBoolean DS UnitInvis(HUNIT arg1);
	jBoolean DS UnitIsSleeping(HUNIT whichUnit);
	HITEM DS UnitItemInSlot(HUNIT whichUnit, jInteger itemSlot);
	jBoolean DS UnitMakeAbilityPermanent(HUNIT whichUnit, jBoolean permanent, jInteger abilityId);
	jBoolean DS UnitModifySkillPoints(HUNIT whichHero, jInteger skillPointDelta);
	jNothing DS UnitPauseTimedLife(HUNIT whichUnit, jBoolean flag);
	jNothing DS UnitPoolAddUnitType(HUNITPOOL whichPool, jInteger unitId, jReal* weight);
	jNothing DS UnitPoolRemoveUnitType(HUNITPOOL whichPool, jInteger unitId);
	jBoolean DS UnitRemoveAbility(HUNIT whichUnit, jInteger abilityId);
	jNothing DS UnitRemoveBuffs(HUNIT whichUnit, jBoolean removePositive, jBoolean removeNegative);
	jNothing DS UnitRemoveBuffsEx(HUNIT whichUnit, jBoolean removePositive, jBoolean removeNegative, jBoolean magic, jBoolean physical, jBoolean timedLife, jBoolean aura, jBoolean autoDispel);
	jNothing DS UnitRemoveItem(HUNIT whichUnit, HITEM whichItem);
	HITEM DS UnitRemoveItemFromSlot(HUNIT whichUnit, jInteger itemSlot);
	jBoolean DS UnitRemoveType(HUNIT whichUnit, HUNITTYPE whichUnitType);
	jNothing DS UnitResetCooldown(HUNIT whichUnit);
	jNothing DS UnitSetConstructionProgress(HUNIT whichUnit, jInteger constructionPercentage);
	jNothing DS UnitSetUpgradeProgress(HUNIT whichUnit, jInteger upgradePercentage);
	jNothing DS UnitSetUsesAltIcon(HUNIT whichUnit, jBoolean flag);
	jNothing DS UnitShareVision(HUNIT whichUnit, HPLAYER whichPlayer, jBoolean share);
	jBoolean DS UnitStripHeroLevel(HUNIT whichHero, jInteger howManyLevels);
	jNothing DS UnitSuspendDecay(HUNIT whichUnit, jBoolean suspend);
	jBoolean DS UnitUseItem(HUNIT whichUnit, HITEM whichItem);
	jBoolean DS UnitUseItemPoint(HUNIT whichUnit, HITEM whichItem, jReal* x, jReal* y);
	jBoolean DS UnitUseItemTarget(HUNIT whichUnit, HITEM whichItem, HWIDGET target);
	jNothing DS UnitWakeUp(HUNIT whichUnit);
	jNothing DS UnregisterStackedSound(HSOUND soundHandle, jBoolean byPosition, jReal* rectwidth, jReal* rectheight);
	jNothing DS Unsummon(HUNIT arg1);
	jBoolean DS VersionCompatible(HVERSION whichVersion);
	HVERSION DS VersionGet();
	jBoolean DS VersionSupported(HVERSION whichVersion);
	jNothing DS VolumeGroupReset();
	jNothing DS VolumeGroupSetVolume(HVOLUMEGROUP vgroup, jReal* scale);
	jBoolean DS WaitGetEnemyBase();
	jNothing DS WaygateActivate(HUNIT waygate, jBoolean activate);
	jReal DS WaygateGetDestinationX(HUNIT waygate);
	jReal DS WaygateGetDestinationY(HUNIT waygate);
	jBoolean DS WaygateIsActive(HUNIT waygate);
	jNothing DS WaygateSetDestination(HUNIT waygate, jReal* x, jReal* y);
}

/*const boolean            FALSE = false;
const boolean            TRUE = true;
const jInteger            JASS_MAX_ARRAY_SIZE = 8192;

const jInteger            PLAYER_NEUTRAL_PASSIVE = 15;
const jInteger            PLAYER_NEUTRAL_AGGRESSIVE = 12;

const HPLAYER			PLAYER_0 = JassNatives::Player(0);
const HPLAYER			PLAYER_1 = JassNatives::Player(1);
const HPLAYER			PLAYER_2 = JassNatives::Player(2);
const HPLAYER			PLAYER_3 = JassNatives::Player(3);
const HPLAYER			PLAYER_4 = JassNatives::Player(4);
const HPLAYER			PLAYER_5 = JassNatives::Player(5);
const HPLAYER			PLAYER_6 = JassNatives::Player(6);
const HPLAYER			PLAYER_7 = JassNatives::Player(7);
const HPLAYER			PLAYER_8 = JassNatives::Player(8);
const HPLAYER			PLAYER_9 = JassNatives::Player(9);
const HPLAYER			PLAYER_10 = JassNatives::Player(10);
const HPLAYER			PLAYER_11 = JassNatives::Player(11);

const HPLAYERCOLOR       PLAYER_COLOR_RED = JassNatives::ConvertPlayerColor(0);
const HPLAYERCOLOR       PLAYER_COLOR_BLUE = JassNatives::ConvertPlayerColor(1);
const HPLAYERCOLOR       PLAYER_COLOR_CYAN = JassNatives::ConvertPlayerColor(2);
const HPLAYERCOLOR       PLAYER_COLOR_PURPLE = JassNatives::ConvertPlayerColor(3);
const HPLAYERCOLOR       PLAYER_COLOR_YELLOW = JassNatives::ConvertPlayerColor(4);
const HPLAYERCOLOR       PLAYER_COLOR_ORANGE = JassNatives::ConvertPlayerColor(5);
const HPLAYERCOLOR       PLAYER_COLOR_GREEN = JassNatives::ConvertPlayerColor(6);
const HPLAYERCOLOR       PLAYER_COLOR_PINK = JassNatives::ConvertPlayerColor(7);
const HPLAYERCOLOR       PLAYER_COLOR_LIGHT_GRAY = JassNatives::ConvertPlayerColor(8);
const HPLAYERCOLOR       PLAYER_COLOR_LIGHT_BLUE = JassNatives::ConvertPlayerColor(9);
const HPLAYERCOLOR       PLAYER_COLOR_AQUA = JassNatives::ConvertPlayerColor(10);
const HPLAYERCOLOR       PLAYER_COLOR_BROWN = JassNatives::ConvertPlayerColor(11);

const HRACE              RACE_HUMAN = JassNatives::ConvertRace(1);
const HRACE              RACE_ORC = JassNatives::ConvertRace(2);
const HRACE              RACE_UNDEAD = JassNatives::ConvertRace(3);
const HRACE              RACE_NIGHTELF = JassNatives::ConvertRace(4);
const HRACE              RACE_DEMON = JassNatives::ConvertRace(5);
const HRACE              RACE_OTHER = JassNatives::ConvertRace(7);

const HPLAYERGAMERESULT   PLAYER_GAME_RESULT_VICTORY = JassNatives::ConvertPlayerGameResult(0);
const HPLAYERGAMERESULT   PLAYER_GAME_RESULT_DEFEAT = JassNatives::ConvertPlayerGameResult(1);
const HPLAYERGAMERESULT   PLAYER_GAME_RESULT_TIE = JassNatives::ConvertPlayerGameResult(2);
const HPLAYERGAMERESULT   PLAYER_GAME_RESULT_NEUTRAL = JassNatives::ConvertPlayerGameResult(3);

const HALLIANCETYPE      ALLIANCE_PASSIVE = JassNatives::ConvertAllianceType(0);
const HALLIANCETYPE      ALLIANCE_HELP_REQUEST = JassNatives::ConvertAllianceType(1);
const HALLIANCETYPE      ALLIANCE_HELP_RESPONSE = JassNatives::ConvertAllianceType(2);
const HALLIANCETYPE      ALLIANCE_SHARED_XP = JassNatives::ConvertAllianceType(3);
const HALLIANCETYPE      ALLIANCE_SHARED_SPELLS = JassNatives::ConvertAllianceType(4);
const HALLIANCETYPE      ALLIANCE_SHARED_VISION = JassNatives::ConvertAllianceType(5);
const HALLIANCETYPE      ALLIANCE_SHARED_CONTROL = JassNatives::ConvertAllianceType(6);
const HALLIANCETYPE      ALLIANCE_SHARED_ADVANCED_CONTROL = JassNatives::ConvertAllianceType(7);
const HALLIANCETYPE      ALLIANCE_RESCUABLE = JassNatives::ConvertAllianceType(8);
const HALLIANCETYPE      ALLIANCE_SHARED_VISION_FORCED = JassNatives::ConvertAllianceType(9);

const HVERSION           VERSION_REIGN_OF_CHAOS = JassNatives::ConvertVersion(0);
const HVERSION           VERSION_FROZEN_THRONE = JassNatives::ConvertVersion(1);

const HATTACKTYPE        ATTACK_TYPE_NORMAL = JassNatives::ConvertAttackType(0);
const HATTACKTYPE        ATTACK_TYPE_MELEE = JassNatives::ConvertAttackType(1);
const HATTACKTYPE        ATTACK_TYPE_PIERCE = JassNatives::ConvertAttackType(2);
const HATTACKTYPE        ATTACK_TYPE_SIEGE = JassNatives::ConvertAttackType(3);
const HATTACKTYPE        ATTACK_TYPE_MAGIC = JassNatives::ConvertAttackType(4);
const HATTACKTYPE        ATTACK_TYPE_CHAOS = JassNatives::ConvertAttackType(5);
const HATTACKTYPE        ATTACK_TYPE_HERO = JassNatives::ConvertAttackType(6);

const HDAMAGETYPE        DAMAGE_TYPE_UNKNOWN = JassNatives::ConvertDamageType(0);
const HDAMAGETYPE        DAMAGE_TYPE_NORMAL = JassNatives::ConvertDamageType(4);
const HDAMAGETYPE        DAMAGE_TYPE_ENHANCED = JassNatives::ConvertDamageType(5);
const HDAMAGETYPE        DAMAGE_TYPE_FIRE = JassNatives::ConvertDamageType(8);
const HDAMAGETYPE        DAMAGE_TYPE_COLD = JassNatives::ConvertDamageType(9);
const HDAMAGETYPE        DAMAGE_TYPE_LIGHTNING = JassNatives::ConvertDamageType(10);
const HDAMAGETYPE        DAMAGE_TYPE_POISON = JassNatives::ConvertDamageType(11);
const HDAMAGETYPE        DAMAGE_TYPE_DISEASE = JassNatives::ConvertDamageType(12);
const HDAMAGETYPE        DAMAGE_TYPE_DIVINE = JassNatives::ConvertDamageType(13);
const HDAMAGETYPE        DAMAGE_TYPE_MAGIC = JassNatives::ConvertDamageType(14);
const HDAMAGETYPE        DAMAGE_TYPE_SONIC = JassNatives::ConvertDamageType(15);
const HDAMAGETYPE        DAMAGE_TYPE_ACID = JassNatives::ConvertDamageType(16);
const HDAMAGETYPE        DAMAGE_TYPE_FORCE = JassNatives::ConvertDamageType(17);
const HDAMAGETYPE        DAMAGE_TYPE_DEATH = JassNatives::ConvertDamageType(18);
const HDAMAGETYPE        DAMAGE_TYPE_MIND = JassNatives::ConvertDamageType(19);
const HDAMAGETYPE        DAMAGE_TYPE_PLANT = JassNatives::ConvertDamageType(20);
const HDAMAGETYPE        DAMAGE_TYPE_DEFENSIVE = JassNatives::ConvertDamageType(21);
const HDAMAGETYPE        DAMAGE_TYPE_DEMOLITION = JassNatives::ConvertDamageType(22);
const HDAMAGETYPE        DAMAGE_TYPE_SLOW_POISON = JassNatives::ConvertDamageType(23);
const HDAMAGETYPE        DAMAGE_TYPE_SPIRIT_LINK = JassNatives::ConvertDamageType(24);
const HDAMAGETYPE        DAMAGE_TYPE_SHADOW_STRIKE = JassNatives::ConvertDamageType(25);
const HDAMAGETYPE        DAMAGE_TYPE_UNIVERSAL = JassNatives::ConvertDamageType(26);

const HWEAPONTYPE        WEAPON_TYPE_WHOKNOWS = JassNatives::ConvertWeaponType(0);
const HWEAPONTYPE        WEAPON_TYPE_METAL_LIGHT_CHOP = JassNatives::ConvertWeaponType(1);
const HWEAPONTYPE        WEAPON_TYPE_METAL_MEDIUM_CHOP = JassNatives::ConvertWeaponType(2);
const HWEAPONTYPE        WEAPON_TYPE_METAL_HEAVY_CHOP = JassNatives::ConvertWeaponType(3);
const HWEAPONTYPE        WEAPON_TYPE_METAL_LIGHT_SLICE = JassNatives::ConvertWeaponType(4);
const HWEAPONTYPE        WEAPON_TYPE_METAL_MEDIUM_SLICE = JassNatives::ConvertWeaponType(5);
const HWEAPONTYPE        WEAPON_TYPE_METAL_HEAVY_SLICE = JassNatives::ConvertWeaponType(6);
const HWEAPONTYPE        WEAPON_TYPE_METAL_MEDIUM_BASH = JassNatives::ConvertWeaponType(7);
const HWEAPONTYPE        WEAPON_TYPE_METAL_HEAVY_BASH = JassNatives::ConvertWeaponType(8);
const HWEAPONTYPE        WEAPON_TYPE_METAL_MEDIUM_STAB = JassNatives::ConvertWeaponType(9);
const HWEAPONTYPE        WEAPON_TYPE_METAL_HEAVY_STAB = JassNatives::ConvertWeaponType(10);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_LIGHT_SLICE = JassNatives::ConvertWeaponType(11);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_MEDIUM_SLICE = JassNatives::ConvertWeaponType(12);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_HEAVY_SLICE = JassNatives::ConvertWeaponType(13);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_LIGHT_BASH = JassNatives::ConvertWeaponType(14);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_MEDIUM_BASH = JassNatives::ConvertWeaponType(15);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_HEAVY_BASH = JassNatives::ConvertWeaponType(16);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_LIGHT_STAB = JassNatives::ConvertWeaponType(17);
const HWEAPONTYPE        WEAPON_TYPE_WOOD_MEDIUM_STAB = JassNatives::ConvertWeaponType(18);
const HWEAPONTYPE        WEAPON_TYPE_CLAW_LIGHT_SLICE = JassNatives::ConvertWeaponType(19);
const HWEAPONTYPE        WEAPON_TYPE_CLAW_MEDIUM_SLICE = JassNatives::ConvertWeaponType(20);
const HWEAPONTYPE        WEAPON_TYPE_CLAW_HEAVY_SLICE = JassNatives::ConvertWeaponType(21);
const HWEAPONTYPE        WEAPON_TYPE_AXE_MEDIUM_CHOP = JassNatives::ConvertWeaponType(22);
const HWEAPONTYPE        WEAPON_TYPE_ROCK_HEAVY_BASH = JassNatives::ConvertWeaponType(23);

const HPATHINGTYPE       PATHING_TYPE_ANY = JassNatives::ConvertPathingType(0);
const HPATHINGTYPE       PATHING_TYPE_WALKABILITY = JassNatives::ConvertPathingType(1);
const HPATHINGTYPE       PATHING_TYPE_FLYABILITY = JassNatives::ConvertPathingType(2);
const HPATHINGTYPE       PATHING_TYPE_BUILDABILITY = JassNatives::ConvertPathingType(3);
const HPATHINGTYPE       PATHING_TYPE_PEONHARVESTPATHING = JassNatives::ConvertPathingType(4);
const HPATHINGTYPE       PATHING_TYPE_BLIGHTPATHING = JassNatives::ConvertPathingType(5);
const HPATHINGTYPE       PATHING_TYPE_FLOATABILITY = JassNatives::ConvertPathingType(6);
const HPATHINGTYPE       PATHING_TYPE_AMPHIBIOUSPATHING = JassNatives::ConvertPathingType(7);

const HRACEPREFERENCE    RACE_PREF_HUMAN = JassNatives::ConvertRacePref(1);
const HRACEPREFERENCE    RACE_PREF_ORC = JassNatives::ConvertRacePref(2);
const HRACEPREFERENCE    RACE_PREF_NIGHTELF = JassNatives::ConvertRacePref(4);
const HRACEPREFERENCE    RACE_PREF_UNDEAD = JassNatives::ConvertRacePref(8);
const HRACEPREFERENCE    RACE_PREF_DEMON = JassNatives::ConvertRacePref(16);
const HRACEPREFERENCE    RACE_PREF_RANDOM = JassNatives::ConvertRacePref(32);
const HRACEPREFERENCE    RACE_PREF_USER_SELECTABLE = JassNatives::ConvertRacePref(64);

const HMAPCONTROL        MAP_CONTROL_USER = JassNatives::ConvertMapControl(0);
const HMAPCONTROL        MAP_CONTROL_COMPUTER = JassNatives::ConvertMapControl(1);
const HMAPCONTROL        MAP_CONTROL_RESCUABLE = JassNatives::ConvertMapControl(2);
const HMAPCONTROL        MAP_CONTROL_NEUTRAL = JassNatives::ConvertMapControl(3);
const HMAPCONTROL        MAP_CONTROL_CREEP = JassNatives::ConvertMapControl(4);
const HMAPCONTROL        MAP_CONTROL_NONE = JassNatives::ConvertMapControl(5);

const HGAMETYPE          GAME_TYPE_MELEE = JassNatives::ConvertGameType(1);
const HGAMETYPE          GAME_TYPE_FFA = JassNatives::ConvertGameType(2);
const HGAMETYPE          GAME_TYPE_USE_MAP_SETTINGS = JassNatives::ConvertGameType(4);
const HGAMETYPE          GAME_TYPE_BLIZ = JassNatives::ConvertGameType(8);
const HGAMETYPE          GAME_TYPE_ONE_ON_ONE = JassNatives::ConvertGameType(16);
const HGAMETYPE          GAME_TYPE_TWO_TEAM_PLAY = JassNatives::ConvertGameType(32);
const HGAMETYPE          GAME_TYPE_THREE_TEAM_PLAY = JassNatives::ConvertGameType(64);
const HGAMETYPE          GAME_TYPE_FOUR_TEAM_PLAY = JassNatives::ConvertGameType(128);

const HMAPFLAG           MAP_FOG_HIDE_TERRAIN = JassNatives::ConvertMapFlag(1);
const HMAPFLAG           MAP_FOG_MAP_EXPLORED = JassNatives::ConvertMapFlag(2);
const HMAPFLAG           MAP_FOG_ALWAYS_VISIBLE = JassNatives::ConvertMapFlag(4);

const HMAPFLAG           MAP_USE_HANDICAPS = JassNatives::ConvertMapFlag(8);
const HMAPFLAG           MAP_OBSERVERS = JassNatives::ConvertMapFlag(16);
const HMAPFLAG           MAP_OBSERVERS_ON_DEATH = JassNatives::ConvertMapFlag(32);

const HMAPFLAG           MAP_FIXED_COLORS = JassNatives::ConvertMapFlag(128);

const HMAPFLAG           MAP_LOCK_RESOURCE_TRADING = JassNatives::ConvertMapFlag(256);
const HMAPFLAG           MAP_RESOURCE_TRADING_ALLIES_ONLY = JassNatives::ConvertMapFlag(512);

const HMAPFLAG           MAP_LOCK_ALLIANCE_CHANGES = JassNatives::ConvertMapFlag(1024);
const HMAPFLAG           MAP_ALLIANCE_CHANGES_HIDDEN = JassNatives::ConvertMapFlag(2048);

const HMAPFLAG           MAP_CHEATS = JassNatives::ConvertMapFlag(4096);
const HMAPFLAG           MAP_CHEATS_HIDDEN = JassNatives::ConvertMapFlag(8192);

const HMAPFLAG           MAP_LOCK_SPEED = JassNatives::ConvertMapFlag(8192 * 2);
const HMAPFLAG           MAP_LOCK_RANDOM_SEED = JassNatives::ConvertMapFlag(8192 * 4);
const HMAPFLAG           MAP_SHARED_ADVANCED_CONTROL = JassNatives::ConvertMapFlag(8192 * 8);
const HMAPFLAG           MAP_RANDOM_HERO = JassNatives::ConvertMapFlag(8192 * 16);
const HMAPFLAG           MAP_RANDOM_RACES = JassNatives::ConvertMapFlag(8192 * 32);
const HMAPFLAG           MAP_RELOADED = JassNatives::ConvertMapFlag(8192 * 64);

const HPLACEMENT         MAP_PLACEMENT_RANDOM = JassNatives::ConvertPlacement(0);
const HPLACEMENT         MAP_PLACEMENT_FIXED = JassNatives::ConvertPlacement(1);
const HPLACEMENT         MAP_PLACEMENT_USE_MAP_SETTINGS = JassNatives::ConvertPlacement(2);
const HPLACEMENT         MAP_PLACEMENT_TEAMS_TOGETHER = JassNatives::ConvertPlacement(3);

const HSTARTLOCPRIO      MAP_LOC_PRIO_LOW = JassNatives::ConvertStartLocPrio(0);
const HSTARTLOCPRIO      MAP_LOC_PRIO_HIGH = JassNatives::ConvertStartLocPrio(1);
const HSTARTLOCPRIO      MAP_LOC_PRIO_NOT = JassNatives::ConvertStartLocPrio(2);

const HMAPDENSITY        MAP_DENSITY_NONE = JassNatives::ConvertMapDensity(0);
const HMAPDENSITY        MAP_DENSITY_LIGHT = JassNatives::ConvertMapDensity(1);
const HMAPDENSITY        MAP_DENSITY_MEDIUM = JassNatives::ConvertMapDensity(2);
const HMAPDENSITY        MAP_DENSITY_HEAVY = JassNatives::ConvertMapDensity(3);

const HGAMEDIFFICULTY    MAP_DIFFICULTY_EASY = JassNatives::ConvertGameDifficulty(0);
const HGAMEDIFFICULTY    MAP_DIFFICULTY_NORMAL = JassNatives::ConvertGameDifficulty(1);
const HGAMEDIFFICULTY    MAP_DIFFICULTY_HARD = JassNatives::ConvertGameDifficulty(2);
const HGAMEDIFFICULTY    MAP_DIFFICULTY_INSANE = JassNatives::ConvertGameDifficulty(3);

const HGAMESPEED         MAP_SPEED_SLOWEST = JassNatives::ConvertGameSpeed(0);
const HGAMESPEED         MAP_SPEED_SLOW = JassNatives::ConvertGameSpeed(1);
const HGAMESPEED         MAP_SPEED_NORMAL = JassNatives::ConvertGameSpeed(2);
const HGAMESPEED         MAP_SPEED_FAST = JassNatives::ConvertGameSpeed(3);
const HGAMESPEED         MAP_SPEED_FASTEST = JassNatives::ConvertGameSpeed(4);

const HPLAYERSLOTSTATE   PLAYER_SLOT_STATE_EMPTY = JassNatives::ConvertPlayerSlotState(0);
const HPLAYERSLOTSTATE   PLAYER_SLOT_STATE_PLAYING = JassNatives::ConvertPlayerSlotState(1);
const HPLAYERSLOTSTATE   PLAYER_SLOT_STATE_LEFT = JassNatives::ConvertPlayerSlotState(2);

const HVOLUMEGROUP       SOUND_VOLUMEGROUP_UNITMOVEMENT = JassNatives::ConvertVolumeGroup(0);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_UNITSOUNDS = JassNatives::ConvertVolumeGroup(1);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_COMBAT = JassNatives::ConvertVolumeGroup(2);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_SPELLS = JassNatives::ConvertVolumeGroup(3);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_UI = JassNatives::ConvertVolumeGroup(4);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_MUSIC = JassNatives::ConvertVolumeGroup(5);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_AMBIENTSOUNDS = JassNatives::ConvertVolumeGroup(6);
const HVOLUMEGROUP       SOUND_VOLUMEGROUP_FIRE = JassNatives::ConvertVolumeGroup(7);

const HIGAMESTATE GAME_STATE_DIVINE_INTERVENTION = JassNatives::ConvertIGameState(0);
const HIGAMESTATE GAME_STATE_DISCONNECTED = JassNatives::ConvertIGameState(1);
const HIGAMESTATE GAME_STATE_TIME_OF_DAY = JassNatives::ConvertFGameState(2);

const HPLAYERSTATE PLAYER_STATE_GAME_RESULT = JassNatives::ConvertPlayerState(0);

const HPLAYERSTATE PLAYER_STATE_RESOURCE_GOLD = JassNatives::ConvertPlayerState(1);
const HPLAYERSTATE PLAYER_STATE_RESOURCE_LUMBER = JassNatives::ConvertPlayerState(2);
const HPLAYERSTATE PLAYER_STATE_RESOURCE_HERO_TOKENS = JassNatives::ConvertPlayerState(3);
const HPLAYERSTATE PLAYER_STATE_RESOURCE_FOOD_CAP = JassNatives::ConvertPlayerState(4);
const HPLAYERSTATE PLAYER_STATE_RESOURCE_FOOD_USED = JassNatives::ConvertPlayerState(5);
const HPLAYERSTATE PLAYER_STATE_FOOD_CAP_CEILING = JassNatives::ConvertPlayerState(6);

const HPLAYERSTATE PLAYER_STATE_GIVES_BOUNTY = JassNatives::ConvertPlayerState(7);
const HPLAYERSTATE PLAYER_STATE_ALLIED_VICTORY = JassNatives::ConvertPlayerState(8);
const HPLAYERSTATE PLAYER_STATE_PLACED = JassNatives::ConvertPlayerState(9);
const HPLAYERSTATE PLAYER_STATE_OBSERVER_ON_DEATH = JassNatives::ConvertPlayerState(10);
const HPLAYERSTATE PLAYER_STATE_OBSERVER = JassNatives::ConvertPlayerState(11);
const HPLAYERSTATE PLAYER_STATE_UNFOLLOWABLE = JassNatives::ConvertPlayerState(12);

const HPLAYERSTATE PLAYER_STATE_GOLD_UPKEEP_RATE = JassNatives::ConvertPlayerState(13);
const HPLAYERSTATE PLAYER_STATE_LUMBER_UPKEEP_RATE = JassNatives::ConvertPlayerState(14);

const HPLAYERSTATE PLAYER_STATE_GOLD_GATHERED = JassNatives::ConvertPlayerState(15);
const HPLAYERSTATE PLAYER_STATE_LUMBER_GATHERED = JassNatives::ConvertPlayerState(16);

const HPLAYERSTATE PLAYER_STATE_NO_CREEP_SLEEP = JassNatives::ConvertPlayerState(25);

const HUNITSTATE UNIT_STATE_LIFE = JassNatives::ConvertUnitState(0);
const HUNITSTATE UNIT_STATE_MAX_LIFE = JassNatives::ConvertUnitState(1);
const HUNITSTATE UNIT_STATE_MANA = JassNatives::ConvertUnitState(2);
const HUNITSTATE UNIT_STATE_MAX_MANA = JassNatives::ConvertUnitState(3);

const HAIDIFFICULTY AI_DIFFICULTY_NEWBIE = JassNatives::ConvertAIDifficulty(0);
const HAIDIFFICULTY AI_DIFFICULTY_NORMAL = JassNatives::ConvertAIDifficulty(1);
const HAIDIFFICULTY AI_DIFFICULTY_INSANE = JassNatives::ConvertAIDifficulty(2);

const HPLAYERSCORE PLAYER_SCORE_UNITS_TRAINED = JassNatives::ConvertPlayerScore(0);
const HPLAYERSCORE PLAYER_SCORE_UNITS_KILLED = JassNatives::ConvertPlayerScore(1);
const HPLAYERSCORE PLAYER_SCORE_STRUCT_BUILT = JassNatives::ConvertPlayerScore(2);
const HPLAYERSCORE PLAYER_SCORE_STRUCT_RAZED = JassNatives::ConvertPlayerScore(3);
const HPLAYERSCORE PLAYER_SCORE_TECH_PERCENT = JassNatives::ConvertPlayerScore(4);
const HPLAYERSCORE PLAYER_SCORE_FOOD_MAXPROD = JassNatives::ConvertPlayerScore(5);
const HPLAYERSCORE PLAYER_SCORE_FOOD_MAXUSED = JassNatives::ConvertPlayerScore(6);
const HPLAYERSCORE PLAYER_SCORE_HEROES_KILLED = JassNatives::ConvertPlayerScore(7);
const HPLAYERSCORE PLAYER_SCORE_ITEMS_GAINED = JassNatives::ConvertPlayerScore(8);
const HPLAYERSCORE PLAYER_SCORE_MERCS_HIRED = JassNatives::ConvertPlayerScore(9);
const HPLAYERSCORE PLAYER_SCORE_GOLD_MINED_TOTAL = JassNatives::ConvertPlayerScore(10);
const HPLAYERSCORE PLAYER_SCORE_GOLD_MINED_UPKEEP = JassNatives::ConvertPlayerScore(11);
const HPLAYERSCORE PLAYER_SCORE_GOLD_LOST_UPKEEP = JassNatives::ConvertPlayerScore(12);
const HPLAYERSCORE PLAYER_SCORE_GOLD_LOST_TAX = JassNatives::ConvertPlayerScore(13);
const HPLAYERSCORE PLAYER_SCORE_GOLD_GIVEN = JassNatives::ConvertPlayerScore(14);
const HPLAYERSCORE PLAYER_SCORE_GOLD_RECEIVED = JassNatives::ConvertPlayerScore(15);
const HPLAYERSCORE PLAYER_SCORE_LUMBER_TOTAL = JassNatives::ConvertPlayerScore(16);
const HPLAYERSCORE PLAYER_SCORE_LUMBER_LOST_UPKEEP = JassNatives::ConvertPlayerScore(17);
const HPLAYERSCORE PLAYER_SCORE_LUMBER_LOST_TAX = JassNatives::ConvertPlayerScore(18);
const HPLAYERSCORE PLAYER_SCORE_LUMBER_GIVEN = JassNatives::ConvertPlayerScore(19);
const HPLAYERSCORE PLAYER_SCORE_LUMBER_RECEIVED = JassNatives::ConvertPlayerScore(20);
const HPLAYERSCORE PLAYER_SCORE_UNIT_TOTAL = JassNatives::ConvertPlayerScore(21);
const HPLAYERSCORE PLAYER_SCORE_HERO_TOTAL = JassNatives::ConvertPlayerScore(22);
const HPLAYERSCORE PLAYER_SCORE_RESOURCE_TOTAL = JassNatives::ConvertPlayerScore(23);
const HPLAYERSCORE PLAYER_SCORE_TOTAL = JassNatives::ConvertPlayerScore(24);

const HGAMEEVENT EVENT_GAME_VICTORY = JassNatives::ConvertGameEvent(0);
const HGAMEEVENT EVENT_GAME_END_LEVEL = JassNatives::ConvertGameEvent(1);

const HGAMEEVENT EVENT_GAME_VARIABLE_LIMIT = JassNatives::ConvertGameEvent(2);
const HGAMEEVENT EVENT_GAME_STATE_LIMIT = JassNatives::ConvertGameEvent(3);

const HGAMEEVENT EVENT_GAME_TIMER_EXPIRED = JassNatives::ConvertGameEvent(4);

const HGAMEEVENT EVENT_GAME_ENTER_REGION = JassNatives::ConvertGameEvent(5);
const HGAMEEVENT EVENT_GAME_LEAVE_REGION = JassNatives::ConvertGameEvent(6);

const HGAMEEVENT EVENT_GAME_TRACKABLE_HIT = JassNatives::ConvertGameEvent(7);
const HGAMEEVENT EVENT_GAME_TRACKABLE_TRACK = JassNatives::ConvertGameEvent(8);

const HGAMEEVENT EVENT_GAME_SHOW_SKILL = JassNatives::ConvertGameEvent(9);
const HGAMEEVENT EVENT_GAME_BUILD_SUBMENU = JassNatives::ConvertGameEvent(10);

const HPLAYEREVENT EVENT_PLAYER_STATE_LIMIT = JassNatives::ConvertPlayerEvent(11);
const HPLAYEREVENT EVENT_PLAYER_ALLIANCE_CHANGED = JassNatives::ConvertPlayerEvent(12);

const HPLAYEREVENT EVENT_PLAYER_DEFEAT = JassNatives::ConvertPlayerEvent(13);
const HPLAYEREVENT EVENT_PLAYER_VICTORY = JassNatives::ConvertPlayerEvent(14);
const HPLAYEREVENT EVENT_PLAYER_LEAVE = JassNatives::ConvertPlayerEvent(15);
const HPLAYEREVENT EVENT_PLAYER_CHAT = JassNatives::ConvertPlayerEvent(16);
const HPLAYEREVENT EVENT_PLAYER_END_CINEMATIC = JassNatives::ConvertPlayerEvent(17);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_ATTACKED = JassNatives::ConvertPlayerUnitEvent(18);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_RESCUED = JassNatives::ConvertPlayerUnitEvent(19);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_DEATH = JassNatives::ConvertPlayerUnitEvent(20);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_DECAY = JassNatives::ConvertPlayerUnitEvent(21);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_DETECTED = JassNatives::ConvertPlayerUnitEvent(22);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_HIDDEN = JassNatives::ConvertPlayerUnitEvent(23);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_SELECTED = JassNatives::ConvertPlayerUnitEvent(24);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_DESELECTED = JassNatives::ConvertPlayerUnitEvent(25);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_CONSTRUCT_START = JassNatives::ConvertPlayerUnitEvent(26);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_CONSTRUCT_CANCEL = JassNatives::ConvertPlayerUnitEvent(27);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_CONSTRUCT_FINISH = JassNatives::ConvertPlayerUnitEvent(28);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_UPGRADE_START = JassNatives::ConvertPlayerUnitEvent(29);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_UPGRADE_CANCEL = JassNatives::ConvertPlayerUnitEvent(30);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_UPGRADE_FINISH = JassNatives::ConvertPlayerUnitEvent(31);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_TRAIN_START = JassNatives::ConvertPlayerUnitEvent(32);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_TRAIN_CANCEL = JassNatives::ConvertPlayerUnitEvent(33);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_TRAIN_FINISH = JassNatives::ConvertPlayerUnitEvent(34);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_RESEARCH_START = JassNatives::ConvertPlayerUnitEvent(35);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_RESEARCH_CANCEL = JassNatives::ConvertPlayerUnitEvent(36);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_RESEARCH_FINISH = JassNatives::ConvertPlayerUnitEvent(37);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_ISSUED_ORDER = JassNatives::ConvertPlayerUnitEvent(38);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_ISSUED_POINT_ORDER = JassNatives::ConvertPlayerUnitEvent(39);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_ISSUED_TARGET_ORDER = JassNatives::ConvertPlayerUnitEvent(40);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_ISSUED_UNIT_ORDER = JassNatives::ConvertPlayerUnitEvent(40);

const HPLAYERUNITEVENT EVENT_PLAYER_HERO_LEVEL = JassNatives::ConvertPlayerUnitEvent(41);
const HPLAYERUNITEVENT EVENT_PLAYER_HERO_SKILL = JassNatives::ConvertPlayerUnitEvent(42);

const HPLAYERUNITEVENT EVENT_PLAYER_HERO_REVIVABLE = JassNatives::ConvertPlayerUnitEvent(43);

const HPLAYERUNITEVENT EVENT_PLAYER_HERO_REVIVE_START = JassNatives::ConvertPlayerUnitEvent(44);
const HPLAYERUNITEVENT EVENT_PLAYER_HERO_REVIVE_CANCEL = JassNatives::ConvertPlayerUnitEvent(45);
const HPLAYERUNITEVENT EVENT_PLAYER_HERO_REVIVE_FINISH = JassNatives::ConvertPlayerUnitEvent(46);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_SUMMON = JassNatives::ConvertPlayerUnitEvent(47);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_DROP_ITEM = JassNatives::ConvertPlayerUnitEvent(48);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_PICKUP_ITEM = JassNatives::ConvertPlayerUnitEvent(49);
const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_USE_ITEM = JassNatives::ConvertPlayerUnitEvent(50);

const HPLAYERUNITEVENT EVENT_PLAYER_UNIT_LOADED = JassNatives::ConvertPlayerUnitEvent(51);

const HUNITEVENT EVENT_UNIT_DAMAGED = JassNatives::ConvertUnitEvent(52);
const HUNITEVENT EVENT_UNIT_DEATH = JassNatives::ConvertUnitEvent(53);
const HUNITEVENT EVENT_UNIT_DECAY = JassNatives::ConvertUnitEvent(54);
const HUNITEVENT EVENT_UNIT_DETECTED = JassNatives::ConvertUnitEvent(55);
const HUNITEVENT EVENT_UNIT_HIDDEN = JassNatives::ConvertUnitEvent(56);
const HUNITEVENT EVENT_UNIT_SELECTED = JassNatives::ConvertUnitEvent(57);
const HUNITEVENT EVENT_UNIT_DESELECTED = JassNatives::ConvertUnitEvent(58);

const HUNITEVENT EVENT_UNIT_STATE_LIMIT = JassNatives::ConvertUnitEvent(59);

const HUNITEVENT EVENT_UNIT_ACQUIRED_TARGET = JassNatives::ConvertUnitEvent(60);
const HUNITEVENT EVENT_UNIT_TARGET_IN_RANGE = JassNatives::ConvertUnitEvent(61);
const HUNITEVENT EVENT_UNIT_ATTACKED = JassNatives::ConvertUnitEvent(62);
const HUNITEVENT EVENT_UNIT_RESCUED = JassNatives::ConvertUnitEvent(63);

const HUNITEVENT EVENT_UNIT_CONSTRUCT_CANCEL = JassNatives::ConvertUnitEvent(64);
const HUNITEVENT EVENT_UNIT_CONSTRUCT_FINISH = JassNatives::ConvertUnitEvent(65);

const HUNITEVENT EVENT_UNIT_UPGRADE_START = JassNatives::ConvertUnitEvent(66);
const HUNITEVENT EVENT_UNIT_UPGRADE_CANCEL = JassNatives::ConvertUnitEvent(67);
const HUNITEVENT EVENT_UNIT_UPGRADE_FINISH = JassNatives::ConvertUnitEvent(68);

const HUNITEVENT EVENT_UNIT_TRAIN_START = JassNatives::ConvertUnitEvent(69);
const HUNITEVENT EVENT_UNIT_TRAIN_CANCEL = JassNatives::ConvertUnitEvent(70);
const HUNITEVENT EVENT_UNIT_TRAIN_FINISH = JassNatives::ConvertUnitEvent(71);

const HUNITEVENT EVENT_UNIT_RESEARCH_START = JassNatives::ConvertUnitEvent(72);
const HUNITEVENT EVENT_UNIT_RESEARCH_CANCEL = JassNatives::ConvertUnitEvent(73);
const HUNITEVENT EVENT_UNIT_RESEARCH_FINISH = JassNatives::ConvertUnitEvent(74);

const HUNITEVENT EVENT_UNIT_ISSUED_ORDER = JassNatives::ConvertUnitEvent(75);
const HUNITEVENT EVENT_UNIT_ISSUED_POINT_ORDER = JassNatives::ConvertUnitEvent(76);
const HUNITEVENT EVENT_UNIT_ISSUED_TARGET_ORDER = JassNatives::ConvertUnitEvent(77);

const HUNITEVENT EVENT_UNIT_HERO_LEVEL = JassNatives::ConvertUnitEvent(78);
const HUNITEVENT EVENT_UNIT_HERO_SKILL = JassNatives::ConvertUnitEvent(79);

const HUNITEVENT EVENT_UNIT_HERO_REVIVABLE = JassNatives::ConvertUnitEvent(80);
const HUNITEVENT EVENT_UNIT_HERO_REVIVE_START = JassNatives::ConvertUnitEvent(81);
const HUNITEVENT EVENT_UNIT_HERO_REVIVE_CANCEL = JassNatives::ConvertUnitEvent(82);
const HUNITEVENT EVENT_UNIT_HERO_REVIVE_FINISH = JassNatives::ConvertUnitEvent(83);

const HUNITEVENT EVENT_UNIT_SUMMON = JassNatives::ConvertUnitEvent(84);

const HUNITEVENT EVENT_UNIT_DROP_ITEM = JassNatives::ConvertUnitEvent(85);
const HUNITEVENT EVENT_UNIT_PICKUP_ITEM = JassNatives::ConvertUnitEvent(86);
const HUNITEVENT EVENT_UNIT_USE_ITEM = JassNatives::ConvertUnitEvent(87);

const HUNITEVENT EVENT_UNIT_LOADED = JassNatives::ConvertUnitEvent(88);

const HWIDGETEVENT EVENT_WIDGET_DEATH = JassNatives::ConvertWidgetEvent(89);

const HDIALOGEVENT EVENT_DIALOG_BUTTON_CLICK = JassNatives::ConvertDialogEvent(90);
const HDIALOGEVENT EVENT_DIALOG_CLICK = JassNatives::ConvertDialogEvent(91);

const HGAMEEVENT         EVENT_GAME_LOADED = JassNatives::ConvertGameEvent(256);
const HGAMEEVENT         EVENT_GAME_TOURNAMENT_FINISH_SOON = JassNatives::ConvertGameEvent(257);
const HGAMEEVENT         EVENT_GAME_TOURNAMENT_FINISH_NOW = JassNatives::ConvertGameEvent(258);
const HGAMEEVENT         EVENT_GAME_SAVE = JassNatives::ConvertGameEvent(259);

const HPLAYEREVENT       EVENT_PLAYER_ARROW_LEFT_DOWN = JassNatives::ConvertPlayerEvent(261);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_LEFT_UP = JassNatives::ConvertPlayerEvent(262);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_RIGHT_DOWN = JassNatives::ConvertPlayerEvent(263);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_RIGHT_UP = JassNatives::ConvertPlayerEvent(264);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_DOWN_DOWN = JassNatives::ConvertPlayerEvent(265);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_DOWN_UP = JassNatives::ConvertPlayerEvent(266);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_UP_DOWN = JassNatives::ConvertPlayerEvent(267);
const HPLAYEREVENT       EVENT_PLAYER_ARROW_UP_UP = JassNatives::ConvertPlayerEvent(268);

const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SELL = JassNatives::ConvertPlayerUnitEvent(269);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_CHANGE_OWNER = JassNatives::ConvertPlayerUnitEvent(270);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SELL_ITEM = JassNatives::ConvertPlayerUnitEvent(271);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SPELL_CHANNEL = JassNatives::ConvertPlayerUnitEvent(272);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SPELL_CAST = JassNatives::ConvertPlayerUnitEvent(273);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SPELL_EFFECT = JassNatives::ConvertPlayerUnitEvent(274);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SPELL_FINISH = JassNatives::ConvertPlayerUnitEvent(275);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_SPELL_ENDCAST = JassNatives::ConvertPlayerUnitEvent(276);
const HPLAYERUNITEVENT   EVENT_PLAYER_UNIT_PAWN_ITEM = JassNatives::ConvertPlayerUnitEvent(277);

const HUNITEVENT         EVENT_UNIT_SELL = JassNatives::ConvertUnitEvent(286);
const HUNITEVENT         EVENT_UNIT_CHANGE_OWNER = JassNatives::ConvertUnitEvent(287);
const HUNITEVENT         EVENT_UNIT_SELL_ITEM = JassNatives::ConvertUnitEvent(288);
const HUNITEVENT         EVENT_UNIT_SPELL_CHANNEL = JassNatives::ConvertUnitEvent(289);
const HUNITEVENT         EVENT_UNIT_SPELL_CAST = JassNatives::ConvertUnitEvent(290);
const HUNITEVENT         EVENT_UNIT_SPELL_EFFECT = JassNatives::ConvertUnitEvent(291);
const HUNITEVENT         EVENT_UNIT_SPELL_FINISH = JassNatives::ConvertUnitEvent(292);
const HUNITEVENT         EVENT_UNIT_SPELL_ENDCAST = JassNatives::ConvertUnitEvent(293);
const HUNITEVENT         EVENT_UNIT_PAWN_ITEM = JassNatives::ConvertUnitEvent(294);

const HLIMITOP LESS_THAN = JassNatives::ConvertLimitOp(0);
const HLIMITOP LESS_THAN_OR_EQUAL = JassNatives::ConvertLimitOp(1);
const HLIMITOP EQUAL = JassNatives::ConvertLimitOp(2);
const HLIMITOP GREATER_THAN_OR_EQUAL = JassNatives::ConvertLimitOp(3);
const HLIMITOP GREATER_THAN = JassNatives::ConvertLimitOp(4);
const HLIMITOP NOT_EQUAL = JassNatives::ConvertLimitOp(5);

const HUNITTYPE UNIT_TYPE_HERO = JassNatives::ConvertUnitType(0);
const HUNITTYPE UNIT_TYPE_DEAD = JassNatives::ConvertUnitType(1);
const HUNITTYPE UNIT_TYPE_STRUCTURE = JassNatives::ConvertUnitType(2);

const HUNITTYPE UNIT_TYPE_FLYING = JassNatives::ConvertUnitType(3);
const HUNITTYPE UNIT_TYPE_GROUND = JassNatives::ConvertUnitType(4);

const HUNITTYPE UNIT_TYPE_ATTACKS_FLYING = JassNatives::ConvertUnitType(5);
const HUNITTYPE UNIT_TYPE_ATTACKS_GROUND = JassNatives::ConvertUnitType(6);

const HUNITTYPE UNIT_TYPE_MELEE_ATTACKER = JassNatives::ConvertUnitType(7);
const HUNITTYPE UNIT_TYPE_RANGED_ATTACKER = JassNatives::ConvertUnitType(8);

const HUNITTYPE UNIT_TYPE_GIANT = JassNatives::ConvertUnitType(9);
const HUNITTYPE UNIT_TYPE_SUMMONED = JassNatives::ConvertUnitType(10);
const HUNITTYPE UNIT_TYPE_STUNNED = JassNatives::ConvertUnitType(11);
const HUNITTYPE UNIT_TYPE_PLAGUED = JassNatives::ConvertUnitType(12);
const HUNITTYPE UNIT_TYPE_SNARED = JassNatives::ConvertUnitType(13);

const HUNITTYPE UNIT_TYPE_UNDEAD = JassNatives::ConvertUnitType(14);
const HUNITTYPE UNIT_TYPE_MECHANICAL = JassNatives::ConvertUnitType(15);
const HUNITTYPE UNIT_TYPE_PEON = JassNatives::ConvertUnitType(16);
const HUNITTYPE UNIT_TYPE_SAPPER = JassNatives::ConvertUnitType(17);
const HUNITTYPE UNIT_TYPE_TOWNHALL = JassNatives::ConvertUnitType(18);
const HUNITTYPE UNIT_TYPE_ANCIENT = JassNatives::ConvertUnitType(19);

const HUNITTYPE UNIT_TYPE_TAUREN = JassNatives::ConvertUnitType(20);
const HUNITTYPE UNIT_TYPE_POISONED = JassNatives::ConvertUnitType(21);
const HUNITTYPE UNIT_TYPE_POLYMORPHED = JassNatives::ConvertUnitType(22);
const HUNITTYPE UNIT_TYPE_SLEEPING = JassNatives::ConvertUnitType(23);
const HUNITTYPE UNIT_TYPE_RESISTANT = JassNatives::ConvertUnitType(24);
const HUNITTYPE UNIT_TYPE_ETHEREAL = JassNatives::ConvertUnitType(25);
const HUNITTYPE UNIT_TYPE_MAGIC_IMMUNE = JassNatives::ConvertUnitType(26);

const HITEMTYPE ITEM_TYPE_PERMANENT = JassNatives::ConvertItemType(0);
const HITEMTYPE ITEM_TYPE_CHARGED = JassNatives::ConvertItemType(1);
const HITEMTYPE ITEM_TYPE_POWERUP = JassNatives::ConvertItemType(2);
const HITEMTYPE ITEM_TYPE_ARTIFACT = JassNatives::ConvertItemType(3);
const HITEMTYPE ITEM_TYPE_PURCHASABLE = JassNatives::ConvertItemType(4);
const HITEMTYPE ITEM_TYPE_CAMPAIGN = JassNatives::ConvertItemType(5);
const HITEMTYPE ITEM_TYPE_MISCELLANEOUS = JassNatives::ConvertItemType(6);
const HITEMTYPE ITEM_TYPE_UNKNOWN = JassNatives::ConvertItemType(7);
const HITEMTYPE ITEM_TYPE_ANY = JassNatives::ConvertItemType(8);

const HITEMTYPE ITEM_TYPE_TOME = JassNatives::ConvertItemType(2);

const HCAMERAFIELD CAMERA_FIELD_TARGET_DISTANCE = JassNatives::ConvertCameraField(0);
const HCAMERAFIELD CAMERA_FIELD_FARZ = JassNatives::ConvertCameraField(1);
const HCAMERAFIELD CAMERA_FIELD_ANGLE_OF_ATTACK = JassNatives::ConvertCameraField(2);
const HCAMERAFIELD CAMERA_FIELD_FIELD_OF_VIEW = JassNatives::ConvertCameraField(3);
const HCAMERAFIELD CAMERA_FIELD_ROLL = JassNatives::ConvertCameraField(4);
const HCAMERAFIELD CAMERA_FIELD_ROTATION = JassNatives::ConvertCameraField(5);
const HCAMERAFIELD CAMERA_FIELD_ZOFFSET = JassNatives::ConvertCameraField(6);

const HBLENDMODE  BLEND_MODE_NONE = JassNatives::ConvertBlendMode(0);
const HBLENDMODE  BLEND_MODE_DONT_CARE = JassNatives::ConvertBlendMode(0);
const HBLENDMODE  BLEND_MODE_KEYALPHA = JassNatives::ConvertBlendMode(1);
const HBLENDMODE  BLEND_MODE_BLEND = JassNatives::ConvertBlendMode(2);
const HBLENDMODE  BLEND_MODE_ADDITIVE = JassNatives::ConvertBlendMode(3);
const HBLENDMODE  BLEND_MODE_MODULATE = JassNatives::ConvertBlendMode(4);
const HBLENDMODE  BLEND_MODE_MODULATE_2X = JassNatives::ConvertBlendMode(5);

const HRARITYCONTROL RARITY_FREQUENT = JassNatives::ConvertRarityControl(0);
const HRARITYCONTROL RARITY_RARE = JassNatives::ConvertRarityControl(1);

const HTEXMAPFLAGS   TEXMAP_FLAG_NONE = JassNatives::ConvertTexMapFlags(0);
const HTEXMAPFLAGS   TEXMAP_FLAG_WRAP_U = JassNatives::ConvertTexMapFlags(1);
const HTEXMAPFLAGS   TEXMAP_FLAG_WRAP_V = JassNatives::ConvertTexMapFlags(2);
const HTEXMAPFLAGS   TEXMAP_FLAG_WRAP_UV = JassNatives::ConvertTexMapFlags(3);

const HFOGSTATE      FOG_OF_WAR_MASKED = JassNatives::ConvertFogState(1);
const HFOGSTATE      FOG_OF_WAR_FOGGED = JassNatives::ConvertFogState(2);
const HFOGSTATE      FOG_OF_WAR_VISIBLE = JassNatives::ConvertFogState(4);

const jInteger       CAMERA_MARGIN_LEFT = 0;
const jInteger       CAMERA_MARGIN_RIGHT = 1;
const jInteger       CAMERA_MARGIN_TOP = 2;
const jInteger       CAMERA_MARGIN_BOTTOM = 3;

const HEFFECTTYPE    EFFECT_TYPE_EFFECT = JassNatives::ConvertEffectType(0);
const HEFFECTTYPE    EFFECT_TYPE_TARGET = JassNatives::ConvertEffectType(1);
const HEFFECTTYPE    EFFECT_TYPE_CASTER = JassNatives::ConvertEffectType(2);
const HEFFECTTYPE    EFFECT_TYPE_SPECIAL = JassNatives::ConvertEffectType(3);
const HEFFECTTYPE    EFFECT_TYPE_AREA_EFFECT = JassNatives::ConvertEffectType(4);
const HEFFECTTYPE    EFFECT_TYPE_MISSILE = JassNatives::ConvertEffectType(5);
const HEFFECTTYPE    EFFECT_TYPE_LIGHTNING = JassNatives::ConvertEffectType(6);

const HSOUNDTYPE     SOUND_TYPE_EFFECT = JassNatives::ConvertSoundType(0);
const HSOUNDTYPE     SOUND_TYPE_EFFECT_LOOPED = JassNatives::ConvertSoundType(1);*/