#pragma once

/*
Version 1.0.0
*/

#define WIN32_LEAN_AND_MEAN 
#include <Windows.h>
#include <vector>

#ifdef MME_EXPORT
#	define DS __declspec(dllexport)
#else
#	define DS __declspec(dllimport)
#endif

#define DT_LINE 0x00
#define DT_STRING 0x01
#define DT_INT 0x02
#define DT_BOOL 0x03

struct DS Param
{
public:
	Param(LPCSTR _Key, LPCSTR _Value, DWORD _DataType);
	LPSTR lpKey = NULL;
	LPSTR lpValue = NULL;
	DWORD dwDataType = NULL;
};

struct DS Addon
{
public:
	Addon(HMODULE _Module, LPCSTR _Name, LPCSTR _Extension = NULL);
	HMODULE hAddonModule = NULL;
	LPSTR lpAddonName = NULL;
	LPSTR lpAddonFileExtension = "cfg";

	void CreateConfig(std::vector<Param> _Params);
	LPSTR GetConfigString(LPCSTR _Key, LPCSTR _DefaultValue);
	LPSTR GetConfigLine(LPCSTR _Key, LPCSTR _DefaultValue);
	int GetConfigInt(LPCSTR _Key, int _DefaultValue);
	bool GetConfigBool(LPCSTR _Key, bool _DefaultValue);
};

bool DS IsInGame();